#!/usr/bin/env node
import { readCliConfig as wo, log as R, HooksNameEnum as v, createSubcommand as kn, xPrompts as C, getConfigFileCommonOptions as vt, addHuskyHooks as vo, initHandlerCommon as So, readConfigFile as me, lookForParentTarget as Hn, decryptAES as To, encryptAES as Co, getCurrentBranchName as Ao, getCommitByHookName as $o, resolveMergeInfoByGitReflogAction as No, checkCurrentIsRebasing as Po, resolveMergeInfoByCommitMsg as jo, getCurrentBranchLastCommitList as xo, getLastReflogList as Fo, createMainCommand as Uo } from "@done-coding/cli-utils";
import { execSync as Y } from "node:child_process";
import mt, { existsSync as nn, rmSync as Pe } from "node:fs";
import ye, { resolve as Bo } from "node:path";
import { getConfigPath as Do, batchCompileHandler as Lo, MODULE_DEFAULT_CONFIG_RELATIVE_PATH as Io } from "@done-coding/cli-template";
import { getTargetRepoUrl as Mo } from "@done-coding/cli-git";
const Gn = "自定义模版路径", qn = "某个git平台用户仓库", St = {
  name: "create-done-coding",
  version: "0.11.9",
  description: "项目创建命令行工具",
  cliConfig: {
    namespaceDir: ".done-coding",
    moduleName: "create"
  }
};
let at;
const ko = async () => (at || (at = (await wo({
  moduleName: St.cliConfig.moduleName,
  onSuccess({ config: t, cliConfigFileRelativePath: n, repoUrl: r }) {
    if (!Array.isArray(t.templateList)) {
      const o = `远程配置文件出错, templateList 不是数组, 请检查 ${r} ${n}`;
      throw new Error(o);
    }
    R.success("模板列表拉取成功！");
  }
})).templateList), at), Kn = async () => [
  ...await ko(),
  { name: Gn },
  { name: qn }
], Ho = {
  type: "text",
  name: "projectName",
  message: "请输入项目名称",
  format: (e) => e.trim(),
  validate: (e) => e.length > 0 || "项目名称不能为空"
}, Go = async () => ({
  type: "select",
  name: "template",
  message: "请选择模板",
  choices: (await Kn()).map((t) => {
    var n;
    return {
      title: t.branch ? `${t.name}(${t.branch})` : t.name,
      value: t.name,
      description: `${t.description || ""}${(n = t.instances) != null && n.length ? `, 已应用于: ${[""].concat(t.instances).join(`
- `)}` : ""}` || void 0
    };
  }),
  validate: (t) => t.trim().length > 0 || "模板不能为空"
}), qo = {
  type: "confirm",
  name: "saveGitHistory",
  message: "是否保留git历史",
  initial: !1
}, Ko = (e = "项目已存在，是否删除") => ({
  type: "confirm",
  name: "isRemove",
  message: e
}), Wo = {
  type: "text",
  name: "customUrl",
  message: "请输入自定义模板路径",
  validate: (e) => e.trim().length > 0 || "路径不能为空"
}, zo = (e) => ({
  type: "text",
  name: "gitCommitMessage",
  message: "请输入git提交信息",
  initial: `feat: 初始化项目${e}`,
  validate: (t) => t.trim().length > 0 || "提交信息不能为空"
});
var Jo = Object.defineProperty, Vo = (e, t, n) => t in e ? Jo(e, t, { enumerable: !0, configurable: !0, writable: !0, value: n }) : e[t] = n, ee = (e, t, n) => (Vo(e, typeof t != "symbol" ? t + "" : t, n), n), M = /* @__PURE__ */ ((e) => (e.REQUEST_ERROR = "REQUEST_ERROR", e.NO_RESPONSE = "NO_RESPONSE", e.NO_RESPONSE_TIMEOUT = "NO_RESPONSE_TIMEOUT", e.NO_RESPONSE_OFFLINE = "NO_RESPONSE_OFFLINE", e.DISPATCH_RESPONSE = "DISPATCH_RESPONSE", e.DEAL_ERROR = "DEAL_ERROR", e.NO_BUSINESS_CODE = "NO_BUSINESS_CODE", e.NO_NETWORK_CODE = "NO_NETWORK_CODE", e.ABORT = "ABORT", e))(M || {});
class re extends Error {
  constructor({ message: t, code: n, isBusinessError: r }) {
    super(t), ee(this, "code"), ee(this, "isBusinessError"), ee(this, "message"), this.message = t, this.code = n, this.isBusinessError = r, this.name = "DC Request ERROR";
  }
}
class be extends re {
  /**
   * @param cause 错误原因
   */
  constructor({
    message: t,
    code: n,
    cause: r
  }) {
    super({ message: t, code: n, isBusinessError: !1 }), ee(this, "cause"), this.cause = r;
  }
}
class Wn extends re {
  constructor({ message: t, code: n }) {
    super({ message: t, code: n, isBusinessError: !0 });
  }
}
var k = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : typeof global < "u" ? global : typeof self < "u" ? self : {};
function Tt(e) {
  return e && e.__esModule && Object.prototype.hasOwnProperty.call(e, "default") ? e.default : e;
}
var Xo = 200, Ct = "__lodash_hash_undefined__", Qo = 1 / 0, zn = 9007199254740991, Zo = "[object Arguments]", Yo = "[object Function]", es = "[object GeneratorFunction]", ts = "[object Symbol]", ns = /[\\^$.*+?()[\]{}|]/g, rs = /^\[object .+?Constructor\]$/, os = /^(?:0|[1-9]\d*)$/, ss = typeof k == "object" && k && k.Object === Object && k, is = typeof self == "object" && self && self.Object === Object && self, At = ss || is || Function("return this")();
function as(e, t, n) {
  switch (n.length) {
    case 0:
      return e.call(t);
    case 1:
      return e.call(t, n[0]);
    case 2:
      return e.call(t, n[0], n[1]);
    case 3:
      return e.call(t, n[0], n[1], n[2]);
  }
  return e.apply(t, n);
}
function cs(e, t) {
  var n = e ? e.length : 0;
  return !!n && fs(e, t, 0) > -1;
}
function us(e, t, n) {
  for (var r = -1, o = e ? e.length : 0; ++r < o; )
    if (n(t, e[r]))
      return !0;
  return !1;
}
function Jn(e, t) {
  for (var n = -1, r = e ? e.length : 0, o = Array(r); ++n < r; )
    o[n] = t(e[n], n, e);
  return o;
}
function $t(e, t) {
  for (var n = -1, r = t.length, o = e.length; ++n < r; )
    e[o + n] = t[n];
  return e;
}
function ls(e, t, n, r) {
  for (var o = e.length, s = n + (r ? 1 : -1); r ? s-- : ++s < o; )
    if (t(e[s], s, e))
      return s;
  return -1;
}
function fs(e, t, n) {
  if (t !== t)
    return ls(e, ps, n);
  for (var r = n - 1, o = e.length; ++r < o; )
    if (e[r] === t)
      return r;
  return -1;
}
function ps(e) {
  return e !== e;
}
function hs(e, t) {
  for (var n = -1, r = Array(e); ++n < e; )
    r[n] = t(n);
  return r;
}
function ds(e) {
  return function(t) {
    return e(t);
  };
}
function ms(e, t) {
  return e.has(t);
}
function gs(e, t) {
  return e == null ? void 0 : e[t];
}
function ys(e) {
  var t = !1;
  if (e != null && typeof e.toString != "function")
    try {
      t = !!(e + "");
    } catch {
    }
  return t;
}
function Vn(e, t) {
  return function(n) {
    return e(t(n));
  };
}
var Es = Array.prototype, _s = Function.prototype, He = Object.prototype, ct = At["__core-js_shared__"], rn = function() {
  var e = /[^.]+$/.exec(ct && ct.keys && ct.keys.IE_PROTO || "");
  return e ? "Symbol(src)_1." + e : "";
}(), Xn = _s.toString, se = He.hasOwnProperty, Nt = He.toString, bs = RegExp(
  "^" + Xn.call(se).replace(ns, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"
), on = At.Symbol, Rs = Vn(Object.getPrototypeOf, Object), Os = He.propertyIsEnumerable, ws = Es.splice, sn = on ? on.isConcatSpreadable : void 0, gt = Object.getOwnPropertySymbols, an = Math.max, vs = Zn(At, "Map"), Re = Zn(Object, "create");
function W(e) {
  var t = -1, n = e ? e.length : 0;
  for (this.clear(); ++t < n; ) {
    var r = e[t];
    this.set(r[0], r[1]);
  }
}
function Ss() {
  this.__data__ = Re ? Re(null) : {};
}
function Ts(e) {
  return this.has(e) && delete this.__data__[e];
}
function Cs(e) {
  var t = this.__data__;
  if (Re) {
    var n = t[e];
    return n === Ct ? void 0 : n;
  }
  return se.call(t, e) ? t[e] : void 0;
}
function As(e) {
  var t = this.__data__;
  return Re ? t[e] !== void 0 : se.call(t, e);
}
function $s(e, t) {
  var n = this.__data__;
  return n[e] = Re && t === void 0 ? Ct : t, this;
}
W.prototype.clear = Ss;
W.prototype.delete = Ts;
W.prototype.get = Cs;
W.prototype.has = As;
W.prototype.set = $s;
function ie(e) {
  var t = -1, n = e ? e.length : 0;
  for (this.clear(); ++t < n; ) {
    var r = e[t];
    this.set(r[0], r[1]);
  }
}
function Ns() {
  this.__data__ = [];
}
function Ps(e) {
  var t = this.__data__, n = Ge(t, e);
  if (n < 0)
    return !1;
  var r = t.length - 1;
  return n == r ? t.pop() : ws.call(t, n, 1), !0;
}
function js(e) {
  var t = this.__data__, n = Ge(t, e);
  return n < 0 ? void 0 : t[n][1];
}
function xs(e) {
  return Ge(this.__data__, e) > -1;
}
function Fs(e, t) {
  var n = this.__data__, r = Ge(n, e);
  return r < 0 ? n.push([e, t]) : n[r][1] = t, this;
}
ie.prototype.clear = Ns;
ie.prototype.delete = Ps;
ie.prototype.get = js;
ie.prototype.has = xs;
ie.prototype.set = Fs;
function ae(e) {
  var t = -1, n = e ? e.length : 0;
  for (this.clear(); ++t < n; ) {
    var r = e[t];
    this.set(r[0], r[1]);
  }
}
function Us() {
  this.__data__ = {
    hash: new W(),
    map: new (vs || ie)(),
    string: new W()
  };
}
function Bs(e) {
  return qe(this, e).delete(e);
}
function Ds(e) {
  return qe(this, e).get(e);
}
function Ls(e) {
  return qe(this, e).has(e);
}
function Is(e, t) {
  return qe(this, e).set(e, t), this;
}
ae.prototype.clear = Us;
ae.prototype.delete = Bs;
ae.prototype.get = Ds;
ae.prototype.has = Ls;
ae.prototype.set = Is;
function Be(e) {
  var t = -1, n = e ? e.length : 0;
  for (this.__data__ = new ae(); ++t < n; )
    this.add(e[t]);
}
function Ms(e) {
  return this.__data__.set(e, Ct), this;
}
function ks(e) {
  return this.__data__.has(e);
}
Be.prototype.add = Be.prototype.push = Ms;
Be.prototype.has = ks;
function Hs(e, t) {
  var n = Pt(e) || Yn(e) ? hs(e.length, String) : [], r = n.length, o = !!r;
  for (var s in e)
    (t || se.call(e, s)) && !(o && (s == "length" || ei(s, r))) && n.push(s);
  return n;
}
function Ge(e, t) {
  for (var n = e.length; n--; )
    if (ai(e[n][0], t))
      return n;
  return -1;
}
function Gs(e, t, n, r) {
  var o = -1, s = cs, i = !0, a = e.length, u = [], f = t.length;
  if (!a)
    return u;
  n && (t = Jn(t, ds(n))), r ? (s = us, i = !1) : t.length >= Xo && (s = ms, i = !1, t = new Be(t));
  e:
    for (; ++o < a; ) {
      var c = e[o], p = n ? n(c) : c;
      if (c = r || c !== 0 ? c : 0, i && p === p) {
        for (var g = f; g--; )
          if (t[g] === p)
            continue e;
        u.push(c);
      } else
        s(t, p, r) || u.push(c);
    }
  return u;
}
function Qn(e, t, n, r, o) {
  var s = -1, i = e.length;
  for (n || (n = Ys), o || (o = []); ++s < i; ) {
    var a = e[s];
    t > 0 && n(a) ? t > 1 ? Qn(a, t - 1, n, r, o) : $t(o, a) : r || (o[o.length] = a);
  }
  return o;
}
function qs(e, t, n) {
  var r = t(e);
  return Pt(e) ? r : $t(r, n(e));
}
function Ks(e) {
  if (!jt(e) || ni(e))
    return !1;
  var t = tr(e) || ys(e) ? bs : rs;
  return t.test(ii(e));
}
function Ws(e) {
  if (!jt(e))
    return oi(e);
  var t = ri(e), n = [];
  for (var r in e)
    r == "constructor" && (t || !se.call(e, r)) || n.push(r);
  return n;
}
function zs(e, t) {
  return e = Object(e), Js(e, t, function(n, r) {
    return r in e;
  });
}
function Js(e, t, n) {
  for (var r = -1, o = t.length, s = {}; ++r < o; ) {
    var i = t[r], a = e[i];
    n(a, i) && (s[i] = a);
  }
  return s;
}
function Vs(e, t) {
  return t = an(t === void 0 ? e.length - 1 : t, 0), function() {
    for (var n = arguments, r = -1, o = an(n.length - t, 0), s = Array(o); ++r < o; )
      s[r] = n[t + r];
    r = -1;
    for (var i = Array(t + 1); ++r < t; )
      i[r] = n[r];
    return i[t] = s, as(e, this, i);
  };
}
function Xs(e) {
  return qs(e, fi, Zs);
}
function qe(e, t) {
  var n = e.__data__;
  return ti(t) ? n[typeof t == "string" ? "string" : "hash"] : n.map;
}
function Zn(e, t) {
  var n = gs(e, t);
  return Ks(n) ? n : void 0;
}
var Qs = gt ? Vn(gt, Object) : rr, Zs = gt ? function(e) {
  for (var t = []; e; )
    $t(t, Qs(e)), e = Rs(e);
  return t;
} : rr;
function Ys(e) {
  return Pt(e) || Yn(e) || !!(sn && e && e[sn]);
}
function ei(e, t) {
  return t = t ?? zn, !!t && (typeof e == "number" || os.test(e)) && e > -1 && e % 1 == 0 && e < t;
}
function ti(e) {
  var t = typeof e;
  return t == "string" || t == "number" || t == "symbol" || t == "boolean" ? e !== "__proto__" : e === null;
}
function ni(e) {
  return !!rn && rn in e;
}
function ri(e) {
  var t = e && e.constructor, n = typeof t == "function" && t.prototype || He;
  return e === n;
}
function oi(e) {
  var t = [];
  if (e != null)
    for (var n in Object(e))
      t.push(n);
  return t;
}
function si(e) {
  if (typeof e == "string" || li(e))
    return e;
  var t = e + "";
  return t == "0" && 1 / e == -Qo ? "-0" : t;
}
function ii(e) {
  if (e != null) {
    try {
      return Xn.call(e);
    } catch {
    }
    try {
      return e + "";
    } catch {
    }
  }
  return "";
}
function ai(e, t) {
  return e === t || e !== e && t !== t;
}
function Yn(e) {
  return ci(e) && se.call(e, "callee") && (!Os.call(e, "callee") || Nt.call(e) == Zo);
}
var Pt = Array.isArray;
function er(e) {
  return e != null && ui(e.length) && !tr(e);
}
function ci(e) {
  return nr(e) && er(e);
}
function tr(e) {
  var t = jt(e) ? Nt.call(e) : "";
  return t == Yo || t == es;
}
function ui(e) {
  return typeof e == "number" && e > -1 && e % 1 == 0 && e <= zn;
}
function jt(e) {
  var t = typeof e;
  return !!e && (t == "object" || t == "function");
}
function nr(e) {
  return !!e && typeof e == "object";
}
function li(e) {
  return typeof e == "symbol" || nr(e) && Nt.call(e) == ts;
}
function fi(e) {
  return er(e) ? Hs(e, !0) : Ws(e);
}
var pi = Vs(function(e, t) {
  return e == null ? {} : (t = Jn(Qn(t, 1), si), zs(e, Gs(Xs(e), t)));
});
function rr() {
  return [];
}
var hi = pi;
const di = /* @__PURE__ */ Tt(hi);
var H = /* @__PURE__ */ ((e) => (e.LOG = "log", e.WARN = "warn", e.ERROR = "error", e))(H || {}), N = /* @__PURE__ */ ((e) => (e.BEFORE = "1 发起请求前阶段", e.BEFORE_ERROR = "1.1 发起请求前阶段出错", e.BEFORE_ERROR_ORIGIN = "1.1.1 发起请求前阶段-原始错误", e.BEFORE_ERROR_PACK = "1.1.2 发起请求前阶段-包装后错误", e.NETWORK = "2 网络阶段", e.NETWORK_SUCCESS = "2.1 网络成功阶段", e.NETWORK_SUCCESS_BUSINESS_SUCCESS = "2.1.1 网路成功且业务成功", e.NETWORK_SUCCESS_BUSINESS_FAIL = "2.1.2 网络成功但业务失败", e.NETWORK_SUCCESS_DISPATCH_ERROR = "2.1.3 网络成功但分发业务结果出错", e.NETWORK_ERROR = "2.2 网络出错阶段", e.NETWORK_ERROR_ORIGIN = "2.2.1 网络出错阶段-原始错误", e.NETWORK_ERROR_PACK = "2.2.2 网络出错阶段-包装后错误", e.DEAL_ERROR = "3 处理错误阶段", e.DEAL_ERROR_ERROR = "3.1 处理错误阶段出错", e.DEAL_ERROR_RESULT = "3.2 处理错误结果", e.DEAL_ERROR_RESULT_RELOAD = "3.2.1 处理错误结果-重新请求", e.DEAL_ERROR_RESULT_CONTINUE = "3.2.2 处理错误结果-正常抛错", e))(N || {});
const P = ({
  stage: e,
  data: t
}, n = "log") => {
  console[n](
    e,
    t instanceof re ? di({ ...t }, "cause") : t
  );
}, Ee = (e) => e instanceof Error ? e.message : "未知错误", mi = async (e, {
  getBusinessCode: t,
  getBusinessMsg: n,
  getBusinessData: r,
  businessSuccessCodeList: o = [200],
  isSuccessBusinessCode: s
}, i) => {
  i && P(
    { stage: N.NETWORK_SUCCESS, data: e },
    H.LOG
  );
  try {
    const a = t(e), u = n(e);
    if (s ? s(a) : o.includes(a)) {
      const f = {
        code: a,
        data: r(e),
        message: u
      };
      return i && P(
        {
          stage: N.NETWORK_SUCCESS_BUSINESS_SUCCESS,
          data: f
        },
        H.LOG
      ), f;
    } else {
      if (a === void 0)
        throw new Error("业务code未定义");
      const f = new Wn({
        code: a,
        message: u ?? "未知错误"
      });
      return i && P(
        {
          stage: N.NETWORK_SUCCESS_BUSINESS_FAIL,
          data: f
        },
        H.ERROR
      ), Promise.reject(f);
    }
  } catch (a) {
    i && P(
      {
        stage: N.NETWORK_SUCCESS_DISPATCH_ERROR,
        data: a
      },
      H.ERROR
    );
    const u = new be({
      code: M.DISPATCH_RESPONSE,
      message: Ee(a) ?? "分发响应结果执行出错",
      cause: a
    });
    return Promise.reject(u);
  }
}, gi = (e, t) => (...n) => {
  try {
    return e(...n);
  } catch (r) {
    return console.error(e.name, r, e), t;
  }
}, cn = (e, t) => (...n) => e(...n).catch((r) => (console.error(e.name, r, e), t));
var or = 9007199254740991, yi = "[object Arguments]", Ei = "[object Function]", _i = "[object GeneratorFunction]", bi = /^(?:0|[1-9]\d*)$/;
function Ri(e, t, n) {
  switch (n.length) {
    case 0:
      return e.call(t);
    case 1:
      return e.call(t, n[0]);
    case 2:
      return e.call(t, n[0], n[1]);
    case 3:
      return e.call(t, n[0], n[1], n[2]);
  }
  return e.apply(t, n);
}
function Oi(e, t) {
  for (var n = -1, r = Array(e); ++n < e; )
    r[n] = t(n);
  return r;
}
function wi(e, t) {
  return function(n) {
    return e(t(n));
  };
}
var Ke = Object.prototype, Ce = Ke.hasOwnProperty, sr = Ke.toString, ir = Ke.propertyIsEnumerable, vi = wi(Object.keys, Object), un = Math.max, Si = !ir.call({ valueOf: 1 }, "valueOf");
function Ti(e, t) {
  var n = xi(e) || ji(e) ? Oi(e.length, String) : [], r = n.length, o = !!r;
  for (var s in e)
    (t || Ce.call(e, s)) && !(o && (s == "length" || cr(s, r))) && n.push(s);
  return n;
}
function ar(e, t, n) {
  var r = e[t];
  (!(Ce.call(e, t) && lr(r, n)) || n === void 0 && !(t in e)) && (e[t] = n);
}
function Ci(e) {
  if (!ur(e))
    return vi(e);
  var t = [];
  for (var n in Object(e))
    Ce.call(e, n) && n != "constructor" && t.push(n);
  return t;
}
function Ai(e, t) {
  return t = un(t === void 0 ? e.length - 1 : t, 0), function() {
    for (var n = arguments, r = -1, o = un(n.length - t, 0), s = Array(o); ++r < o; )
      s[r] = n[t + r];
    r = -1;
    for (var i = Array(t + 1); ++r < t; )
      i[r] = n[r];
    return i[t] = s, Ri(e, this, i);
  };
}
function $i(e, t, n, r) {
  n || (n = {});
  for (var o = -1, s = t.length; ++o < s; ) {
    var i = t[o], a = r ? r(n[i], e[i], i, n, e) : void 0;
    ar(n, i, a === void 0 ? e[i] : a);
  }
  return n;
}
function Ni(e) {
  return Ai(function(t, n) {
    var r = -1, o = n.length, s = o > 1 ? n[o - 1] : void 0, i = o > 2 ? n[2] : void 0;
    for (s = e.length > 3 && typeof s == "function" ? (o--, s) : void 0, i && Pi(n[0], n[1], i) && (s = o < 3 ? void 0 : s, o = 1), t = Object(t); ++r < o; ) {
      var a = n[r];
      a && e(t, a, r, s);
    }
    return t;
  });
}
function cr(e, t) {
  return t = t ?? or, !!t && (typeof e == "number" || bi.test(e)) && e > -1 && e % 1 == 0 && e < t;
}
function Pi(e, t, n) {
  if (!fr(n))
    return !1;
  var r = typeof t;
  return (r == "number" ? We(n) && cr(t, n.length) : r == "string" && t in n) ? lr(n[t], e) : !1;
}
function ur(e) {
  var t = e && e.constructor, n = typeof t == "function" && t.prototype || Ke;
  return e === n;
}
function lr(e, t) {
  return e === t || e !== e && t !== t;
}
function ji(e) {
  return Fi(e) && Ce.call(e, "callee") && (!ir.call(e, "callee") || sr.call(e) == yi);
}
var xi = Array.isArray;
function We(e) {
  return e != null && Bi(e.length) && !Ui(e);
}
function Fi(e) {
  return Di(e) && We(e);
}
function Ui(e) {
  var t = fr(e) ? sr.call(e) : "";
  return t == Ei || t == _i;
}
function Bi(e) {
  return typeof e == "number" && e > -1 && e % 1 == 0 && e <= or;
}
function fr(e) {
  var t = typeof e;
  return !!e && (t == "object" || t == "function");
}
function Di(e) {
  return !!e && typeof e == "object";
}
var Li = Ni(function(e, t) {
  if (Si || ur(t) || We(t)) {
    $i(t, Ii(t), e);
    return;
  }
  for (var n in t)
    Ce.call(t, n) && ar(e, n, t[n]);
});
function Ii(e) {
  return We(e) ? Ti(e) : Ci(e);
}
var Mi = Li;
const ln = /* @__PURE__ */ Tt(Mi);
var ki = "Expected a function", fn = "__lodash_placeholder__", z = 1, ze = 2, Hi = 4, K = 8, _e = 16, te = 32, Oe = 64, pr = 128, Gi = 256, hr = 512, pn = 1 / 0, qi = 9007199254740991, Ki = 17976931348623157e292, hn = NaN, Wi = [
  ["ary", pr],
  ["bind", z],
  ["bindKey", ze],
  ["curry", K],
  ["curryRight", _e],
  ["flip", hr],
  ["partial", te],
  ["partialRight", Oe],
  ["rearg", Gi]
], zi = "[object Function]", Ji = "[object GeneratorFunction]", Vi = "[object Symbol]", Xi = /[\\^$.*+?()[\]{}|]/g, Qi = /^\s+|\s+$/g, Zi = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, Yi = /\{\n\/\* \[wrapped with (.+)\] \*/, ea = /,? & /, ta = /^[-+]0x[0-9a-f]+$/i, na = /^0b[01]+$/i, ra = /^\[object .+?Constructor\]$/, oa = /^0o[0-7]+$/i, sa = /^(?:0|[1-9]\d*)$/, ia = parseInt, aa = typeof k == "object" && k && k.Object === Object && k, ca = typeof self == "object" && self && self.Object === Object && self, Ae = aa || ca || Function("return this")();
function dr(e, t, n) {
  switch (n.length) {
    case 0:
      return e.call(t);
    case 1:
      return e.call(t, n[0]);
    case 2:
      return e.call(t, n[0], n[1]);
    case 3:
      return e.call(t, n[0], n[1], n[2]);
  }
  return e.apply(t, n);
}
function ua(e, t) {
  for (var n = -1, r = e ? e.length : 0; ++n < r && t(e[n], n, e) !== !1; )
    ;
  return e;
}
function la(e, t) {
  var n = e ? e.length : 0;
  return !!n && pa(e, t, 0) > -1;
}
function fa(e, t, n, r) {
  for (var o = e.length, s = n + (r ? 1 : -1); r ? s-- : ++s < o; )
    if (t(e[s], s, e))
      return s;
  return -1;
}
function pa(e, t, n) {
  if (t !== t)
    return fa(e, ha, n);
  for (var r = n - 1, o = e.length; ++r < o; )
    if (e[r] === t)
      return r;
  return -1;
}
function ha(e) {
  return e !== e;
}
function da(e, t) {
  for (var n = e.length, r = 0; n--; )
    e[n] === t && r++;
  return r;
}
function ma(e, t) {
  return e == null ? void 0 : e[t];
}
function ga(e) {
  var t = !1;
  if (e != null && typeof e.toString != "function")
    try {
      t = !!(e + "");
    } catch {
    }
  return t;
}
function mr(e, t) {
  for (var n = -1, r = e.length, o = 0, s = []; ++n < r; ) {
    var i = e[n];
    (i === t || i === fn) && (e[n] = fn, s[o++] = n);
  }
  return s;
}
var ya = Function.prototype, gr = Object.prototype, ut = Ae["__core-js_shared__"], dn = function() {
  var e = /[^.]+$/.exec(ut && ut.keys && ut.keys.IE_PROTO || "");
  return e ? "Symbol(src)_1." + e : "";
}(), yr = ya.toString, Ea = gr.hasOwnProperty, Er = gr.toString, _a = RegExp(
  "^" + yr.call(Ea).replace(Xi, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"
), ba = Object.create, De = Math.max, Ra = Math.min, mn = function() {
  var e = gn(Object, "defineProperty"), t = gn.name;
  return t && t.length > 2 ? e : void 0;
}();
function Oa(e) {
  return oe(e) ? ba(e) : {};
}
function wa(e) {
  if (!oe(e) || Fa(e))
    return !1;
  var t = La(e) || ga(e) ? _a : ra;
  return t.test(Ba(e));
}
function va(e, t, n, r) {
  for (var o = -1, s = e.length, i = n.length, a = -1, u = t.length, f = De(s - i, 0), c = Array(u + f), p = !r; ++a < u; )
    c[a] = t[a];
  for (; ++o < i; )
    (p || o < s) && (c[n[o]] = e[o]);
  for (; f--; )
    c[a++] = e[o++];
  return c;
}
function Sa(e, t, n, r) {
  for (var o = -1, s = e.length, i = -1, a = n.length, u = -1, f = t.length, c = De(s - a, 0), p = Array(c + f), g = !r; ++o < c; )
    p[o] = e[o];
  for (var m = o; ++u < f; )
    p[m + u] = t[u];
  for (; ++i < a; )
    (g || o < s) && (p[m + n[i]] = e[o++]);
  return p;
}
function Ta(e, t) {
  var n = -1, r = e.length;
  for (t || (t = Array(r)); ++n < r; )
    t[n] = e[n];
  return t;
}
function Ca(e, t, n) {
  var r = t & z, o = we(e);
  function s() {
    var i = this && this !== Ae && this instanceof s ? o : e;
    return i.apply(r ? n : this, arguments);
  }
  return s;
}
function we(e) {
  return function() {
    var t = arguments;
    switch (t.length) {
      case 0:
        return new e();
      case 1:
        return new e(t[0]);
      case 2:
        return new e(t[0], t[1]);
      case 3:
        return new e(t[0], t[1], t[2]);
      case 4:
        return new e(t[0], t[1], t[2], t[3]);
      case 5:
        return new e(t[0], t[1], t[2], t[3], t[4]);
      case 6:
        return new e(t[0], t[1], t[2], t[3], t[4], t[5]);
      case 7:
        return new e(t[0], t[1], t[2], t[3], t[4], t[5], t[6]);
    }
    var n = Oa(e.prototype), r = e.apply(n, t);
    return oe(r) ? r : n;
  };
}
function Aa(e, t, n) {
  var r = we(e);
  function o() {
    for (var s = arguments.length, i = Array(s), a = s, u = br(o); a--; )
      i[a] = arguments[a];
    var f = s < 3 && i[0] !== u && i[s - 1] !== u ? [] : mr(i, u);
    if (s -= f.length, s < n)
      return _r(
        e,
        t,
        xt,
        o.placeholder,
        void 0,
        i,
        f,
        void 0,
        void 0,
        n - s
      );
    var c = this && this !== Ae && this instanceof o ? r : e;
    return dr(c, this, i);
  }
  return o;
}
function xt(e, t, n, r, o, s, i, a, u, f) {
  var c = t & pr, p = t & z, g = t & ze, m = t & (K | _e), h = t & hr, y = g ? void 0 : we(e);
  function d() {
    for (var b = arguments.length, E = Array(b), O = b; O--; )
      E[O] = arguments[O];
    if (m)
      var $ = br(d), S = da(E, $);
    if (r && (E = va(E, r, o, m)), s && (E = Sa(E, s, i, m)), b -= S, m && b < f) {
      var F = mr(E, $);
      return _r(
        e,
        t,
        xt,
        d.placeholder,
        n,
        E,
        F,
        a,
        u,
        f - b
      );
    }
    var U = p ? n : this, I = g ? U[e] : e;
    return b = E.length, a ? E = Ua(E, a) : h && b > 1 && E.reverse(), c && u < b && (E.length = u), this && this !== Ae && this instanceof d && (I = y || we(I)), I.apply(U, E);
  }
  return d;
}
function $a(e, t, n, r) {
  var o = t & z, s = we(e);
  function i() {
    for (var a = -1, u = arguments.length, f = -1, c = r.length, p = Array(c + u), g = this && this !== Ae && this instanceof i ? s : e; ++f < c; )
      p[f] = r[f];
    for (; u--; )
      p[f++] = arguments[++a];
    return dr(g, o ? n : this, p);
  }
  return i;
}
function _r(e, t, n, r, o, s, i, a, u, f) {
  var c = t & K, p = c ? i : void 0, g = c ? void 0 : i, m = c ? s : void 0, h = c ? void 0 : s;
  t |= c ? te : Oe, t &= ~(c ? Oe : te), t & Hi || (t &= ~(z | ze));
  var y = n(e, t, o, m, p, h, g, a, u, f);
  return y.placeholder = r, Rr(y, e, t);
}
function Na(e, t, n, r, o, s, i, a) {
  var u = t & ze;
  if (!u && typeof e != "function")
    throw new TypeError(ki);
  var f = r ? r.length : 0;
  if (f || (t &= ~(te | Oe), r = o = void 0), i = i === void 0 ? i : De(yn(i), 0), a = a === void 0 ? a : yn(a), f -= o ? o.length : 0, t & Oe) {
    var c = r, p = o;
    r = o = void 0;
  }
  var g = [
    e,
    t,
    n,
    r,
    o,
    c,
    p,
    s,
    i,
    a
  ];
  if (e = g[0], t = g[1], n = g[2], r = g[3], o = g[4], a = g[9] = g[9] == null ? u ? 0 : e.length : De(g[9] - f, 0), !a && t & (K | _e) && (t &= ~(K | _e)), !t || t == z)
    var m = Ca(e, t, n);
  else
    t == K || t == _e ? m = Aa(e, t, a) : (t == te || t == (z | te)) && !o.length ? m = $a(e, t, n, r) : m = xt.apply(void 0, g);
  return Rr(m, e, t);
}
function br(e) {
  var t = e;
  return t.placeholder;
}
function gn(e, t) {
  var n = ma(e, t);
  return wa(n) ? n : void 0;
}
function Pa(e) {
  var t = e.match(Yi);
  return t ? t[1].split(ea) : [];
}
function ja(e, t) {
  var n = t.length, r = n - 1;
  return t[r] = (n > 1 ? "& " : "") + t[r], t = t.join(n > 2 ? ", " : " "), e.replace(Zi, `{
/* [wrapped with ` + t + `] */
`);
}
function xa(e, t) {
  return t = t ?? qi, !!t && (typeof e == "number" || sa.test(e)) && e > -1 && e % 1 == 0 && e < t;
}
function Fa(e) {
  return !!dn && dn in e;
}
function Ua(e, t) {
  for (var n = e.length, r = Ra(t.length, n), o = Ta(e); r--; ) {
    var s = t[r];
    e[r] = xa(s, n) ? o[s] : void 0;
  }
  return e;
}
var Rr = mn ? function(e, t, n) {
  var r = t + "";
  return mn(e, "toString", {
    configurable: !0,
    enumerable: !1,
    value: Ga(ja(r, Da(Pa(r), n)))
  });
} : qa;
function Ba(e) {
  if (e != null) {
    try {
      return yr.call(e);
    } catch {
    }
    try {
      return e + "";
    } catch {
    }
  }
  return "";
}
function Da(e, t) {
  return ua(Wi, function(n) {
    var r = "_." + n[0];
    t & n[1] && !la(e, r) && e.push(r);
  }), e.sort();
}
function Ft(e, t, n) {
  t = n ? void 0 : t;
  var r = Na(e, K, void 0, void 0, void 0, void 0, void 0, t);
  return r.placeholder = Ft.placeholder, r;
}
function La(e) {
  var t = oe(e) ? Er.call(e) : "";
  return t == zi || t == Ji;
}
function oe(e) {
  var t = typeof e;
  return !!e && (t == "object" || t == "function");
}
function Ia(e) {
  return !!e && typeof e == "object";
}
function Ma(e) {
  return typeof e == "symbol" || Ia(e) && Er.call(e) == Vi;
}
function ka(e) {
  if (!e)
    return e === 0 ? e : 0;
  if (e = Ha(e), e === pn || e === -pn) {
    var t = e < 0 ? -1 : 1;
    return t * Ki;
  }
  return e === e ? e : 0;
}
function yn(e) {
  var t = ka(e), n = t % 1;
  return t === t ? n ? t - n : t : 0;
}
function Ha(e) {
  if (typeof e == "number")
    return e;
  if (Ma(e))
    return hn;
  if (oe(e)) {
    var t = typeof e.valueOf == "function" ? e.valueOf() : e;
    e = oe(t) ? t + "" : t;
  }
  if (typeof e != "string")
    return e === 0 ? e : +e;
  e = e.replace(Qi, "");
  var n = na.test(e);
  return n || oa.test(e) ? ia(e.slice(2), n ? 2 : 8) : ta.test(e) ? hn : +e;
}
function Ga(e) {
  return function() {
    return e;
  };
}
function qa(e) {
  return e;
}
Ft.placeholder = {};
var Ka = Ft;
const Wa = /* @__PURE__ */ Tt(Ka), za = async ({
  cacheOptions: e,
  cacheConfig: t,
  apiConfig: n
}) => {
  const r = t.useCache && !!e;
  let o = "";
  r && (o = gi(e.getKey, "")(n));
  const s = r ? await cn(
    e.getCache,
    Promise.resolve(void 0)
  )(o) : void 0, i = r ? cn(
    Wa(e.setCache)(o),
    Promise.resolve()
  ) : void 0;
  return {
    cacheEnabled: r,
    cacheKey: o,
    cacheResult: s,
    setCache: i
  };
}, Ja = (e, t) => {
  try {
    return e();
  } catch (n) {
    return t && P(
      {
        stage: N.DEAL_ERROR_ERROR,
        data: n
      },
      H.ERROR
    ), {
      canShowErrorToast: !0,
      newError: new be({
        code: M.DEAL_ERROR,
        message: Ee(n) ?? "处理RequestFailResult错误时出错",
        cause: n
      }),
      reload: !1
    };
  }
};
class Va {
  constructor(t) {
    ee(this, "options"), ee(this, "request", async (n, r = !1) => {
      var o;
      r && P({
        stage: N.BEFORE,
        data: n
      });
      const { uiConfig: s = {}, cacheConfig: i = {}, ...a } = n, u = ln({}, this.uiConfig, s), f = ln({}, this.cacheConfig, i), { cacheResult: c, setCache: p } = await za({
        cacheOptions: this.cacheFn,
        cacheConfig: f,
        apiConfig: n
      });
      if (c)
        return c;
      const g = {
        uiConfig: u,
        cacheConfig: f
      }, m = {
        ...a,
        BASE_PATH: this.basePath,
        TIMEOUT: this.timeout,
        debug: r
      };
      try {
        const h = await this.issue(m, g);
        return p == null || p(h, f), h;
      } catch (h) {
        const y = await Ja(() => {
          var d;
          return r && P({
            stage: N.DEAL_ERROR,
            data: h
          }), ((d = this.beforeError) == null ? void 0 : d.call(this, h, {
            apiConfig: n,
            extendConfig: g
          })) || {
            canShowErrorToast: !0,
            newError: h
          };
        }, r);
        if (y.reload)
          return r && P({
            stage: N.DEAL_ERROR_RESULT_RELOAD
          }), this.request(n, r);
        {
          const { newError: d, canShowErrorToast: b = !0 } = y;
          b && (u.errorToast ?? !0) && ((o = this.showToast) == null || o.call(this, d.message));
          let E;
          return d instanceof re ? E = d : d.isBusinessError ? E = new Wn(d) : E = new be(d), r && P({
            stage: N.DEAL_ERROR_RESULT_CONTINUE,
            data: E
          }), Promise.reject(E);
        }
      }
    }), this.options = t;
  }
  get basePath() {
    return this.options.basePath;
  }
  get timeout() {
    return this.options.timeout;
  }
  get uiConfig() {
    return this.options.uiConfig || {};
  }
  get cacheConfig() {
    return this.options.cacheConfig || {};
  }
  /** 缓存相关方法 */
  get cacheFn() {
    return this.options.cache;
  }
  get issue() {
    return this.options.issue;
  }
  get beforeError() {
    return this.options.beforeError;
  }
  get showToast() {
    return this.options.showToast;
  }
}
const Xa = (e) => new Va(e);
var G = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : typeof global < "u" ? global : typeof self < "u" ? self : {};
function Or(e) {
  return e && e.__esModule && Object.prototype.hasOwnProperty.call(e, "default") ? e.default : e;
}
var Qa = 200, Ut = "__lodash_hash_undefined__", Za = 1 / 0, wr = 9007199254740991, Ya = "[object Arguments]", ec = "[object Function]", tc = "[object GeneratorFunction]", nc = "[object Symbol]", rc = /[\\^$.*+?()[\]{}|]/g, oc = /^\[object .+?Constructor\]$/, sc = /^(?:0|[1-9]\d*)$/, ic = typeof G == "object" && G && G.Object === Object && G, ac = typeof self == "object" && self && self.Object === Object && self, Bt = ic || ac || Function("return this")();
function cc(e, t, n) {
  switch (n.length) {
    case 0:
      return e.call(t);
    case 1:
      return e.call(t, n[0]);
    case 2:
      return e.call(t, n[0], n[1]);
    case 3:
      return e.call(t, n[0], n[1], n[2]);
  }
  return e.apply(t, n);
}
function uc(e, t) {
  var n = e ? e.length : 0;
  return !!n && pc(e, t, 0) > -1;
}
function lc(e, t, n) {
  for (var r = -1, o = e ? e.length : 0; ++r < o; )
    if (n(t, e[r]))
      return !0;
  return !1;
}
function vr(e, t) {
  for (var n = -1, r = e ? e.length : 0, o = Array(r); ++n < r; )
    o[n] = t(e[n], n, e);
  return o;
}
function Dt(e, t) {
  for (var n = -1, r = t.length, o = e.length; ++n < r; )
    e[o + n] = t[n];
  return e;
}
function fc(e, t, n, r) {
  for (var o = e.length, s = n + (r ? 1 : -1); r ? s-- : ++s < o; )
    if (t(e[s], s, e))
      return s;
  return -1;
}
function pc(e, t, n) {
  if (t !== t)
    return fc(e, hc, n);
  for (var r = n - 1, o = e.length; ++r < o; )
    if (e[r] === t)
      return r;
  return -1;
}
function hc(e) {
  return e !== e;
}
function dc(e, t) {
  for (var n = -1, r = Array(e); ++n < e; )
    r[n] = t(n);
  return r;
}
function mc(e) {
  return function(t) {
    return e(t);
  };
}
function gc(e, t) {
  return e.has(t);
}
function yc(e, t) {
  return e == null ? void 0 : e[t];
}
function Ec(e) {
  var t = !1;
  if (e != null && typeof e.toString != "function")
    try {
      t = !!(e + "");
    } catch {
    }
  return t;
}
function Sr(e, t) {
  return function(n) {
    return e(t(n));
  };
}
var _c = Array.prototype, bc = Function.prototype, Je = Object.prototype, lt = Bt["__core-js_shared__"], En = function() {
  var e = /[^.]+$/.exec(lt && lt.keys && lt.keys.IE_PROTO || "");
  return e ? "Symbol(src)_1." + e : "";
}(), Tr = bc.toString, ce = Je.hasOwnProperty, Lt = Je.toString, Rc = RegExp(
  "^" + Tr.call(ce).replace(rc, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"
), _n = Bt.Symbol, Oc = Sr(Object.getPrototypeOf, Object), wc = Je.propertyIsEnumerable, vc = _c.splice, bn = _n ? _n.isConcatSpreadable : void 0, yt = Object.getOwnPropertySymbols, Rn = Math.max, Sc = Ar(Bt, "Map"), ve = Ar(Object, "create");
function J(e) {
  var t = -1, n = e ? e.length : 0;
  for (this.clear(); ++t < n; ) {
    var r = e[t];
    this.set(r[0], r[1]);
  }
}
function Tc() {
  this.__data__ = ve ? ve(null) : {};
}
function Cc(e) {
  return this.has(e) && delete this.__data__[e];
}
function Ac(e) {
  var t = this.__data__;
  if (ve) {
    var n = t[e];
    return n === Ut ? void 0 : n;
  }
  return ce.call(t, e) ? t[e] : void 0;
}
function $c(e) {
  var t = this.__data__;
  return ve ? t[e] !== void 0 : ce.call(t, e);
}
function Nc(e, t) {
  var n = this.__data__;
  return n[e] = ve && t === void 0 ? Ut : t, this;
}
J.prototype.clear = Tc;
J.prototype.delete = Cc;
J.prototype.get = Ac;
J.prototype.has = $c;
J.prototype.set = Nc;
function ue(e) {
  var t = -1, n = e ? e.length : 0;
  for (this.clear(); ++t < n; ) {
    var r = e[t];
    this.set(r[0], r[1]);
  }
}
function Pc() {
  this.__data__ = [];
}
function jc(e) {
  var t = this.__data__, n = Ve(t, e);
  if (n < 0)
    return !1;
  var r = t.length - 1;
  return n == r ? t.pop() : vc.call(t, n, 1), !0;
}
function xc(e) {
  var t = this.__data__, n = Ve(t, e);
  return n < 0 ? void 0 : t[n][1];
}
function Fc(e) {
  return Ve(this.__data__, e) > -1;
}
function Uc(e, t) {
  var n = this.__data__, r = Ve(n, e);
  return r < 0 ? n.push([e, t]) : n[r][1] = t, this;
}
ue.prototype.clear = Pc;
ue.prototype.delete = jc;
ue.prototype.get = xc;
ue.prototype.has = Fc;
ue.prototype.set = Uc;
function le(e) {
  var t = -1, n = e ? e.length : 0;
  for (this.clear(); ++t < n; ) {
    var r = e[t];
    this.set(r[0], r[1]);
  }
}
function Bc() {
  this.__data__ = {
    hash: new J(),
    map: new (Sc || ue)(),
    string: new J()
  };
}
function Dc(e) {
  return Xe(this, e).delete(e);
}
function Lc(e) {
  return Xe(this, e).get(e);
}
function Ic(e) {
  return Xe(this, e).has(e);
}
function Mc(e, t) {
  return Xe(this, e).set(e, t), this;
}
le.prototype.clear = Bc;
le.prototype.delete = Dc;
le.prototype.get = Lc;
le.prototype.has = Ic;
le.prototype.set = Mc;
function Le(e) {
  var t = -1, n = e ? e.length : 0;
  for (this.__data__ = new le(); ++t < n; )
    this.add(e[t]);
}
function kc(e) {
  return this.__data__.set(e, Ut), this;
}
function Hc(e) {
  return this.__data__.has(e);
}
Le.prototype.add = Le.prototype.push = kc;
Le.prototype.has = Hc;
function Gc(e, t) {
  var n = It(e) || $r(e) ? dc(e.length, String) : [], r = n.length, o = !!r;
  for (var s in e)
    (t || ce.call(e, s)) && !(o && (s == "length" || tu(s, r))) && n.push(s);
  return n;
}
function Ve(e, t) {
  for (var n = e.length; n--; )
    if (cu(e[n][0], t))
      return n;
  return -1;
}
function qc(e, t, n, r) {
  var o = -1, s = uc, i = !0, a = e.length, u = [], f = t.length;
  if (!a)
    return u;
  n && (t = vr(t, mc(n))), r ? (s = lc, i = !1) : t.length >= Qa && (s = gc, i = !1, t = new Le(t));
  e:
    for (; ++o < a; ) {
      var c = e[o], p = n ? n(c) : c;
      if (c = r || c !== 0 ? c : 0, i && p === p) {
        for (var g = f; g--; )
          if (t[g] === p)
            continue e;
        u.push(c);
      } else
        s(t, p, r) || u.push(c);
    }
  return u;
}
function Cr(e, t, n, r, o) {
  var s = -1, i = e.length;
  for (n || (n = eu), o || (o = []); ++s < i; ) {
    var a = e[s];
    t > 0 && n(a) ? t > 1 ? Cr(a, t - 1, n, r, o) : Dt(o, a) : r || (o[o.length] = a);
  }
  return o;
}
function Kc(e, t, n) {
  var r = t(e);
  return It(e) ? r : Dt(r, n(e));
}
function Wc(e) {
  if (!Mt(e) || ru(e))
    return !1;
  var t = Pr(e) || Ec(e) ? Rc : oc;
  return t.test(au(e));
}
function zc(e) {
  if (!Mt(e))
    return su(e);
  var t = ou(e), n = [];
  for (var r in e)
    r == "constructor" && (t || !ce.call(e, r)) || n.push(r);
  return n;
}
function Jc(e, t) {
  return e = Object(e), Vc(e, t, function(n, r) {
    return r in e;
  });
}
function Vc(e, t, n) {
  for (var r = -1, o = t.length, s = {}; ++r < o; ) {
    var i = t[r], a = e[i];
    n(a, i) && (s[i] = a);
  }
  return s;
}
function Xc(e, t) {
  return t = Rn(t === void 0 ? e.length - 1 : t, 0), function() {
    for (var n = arguments, r = -1, o = Rn(n.length - t, 0), s = Array(o); ++r < o; )
      s[r] = n[t + r];
    r = -1;
    for (var i = Array(t + 1); ++r < t; )
      i[r] = n[r];
    return i[t] = s, cc(e, this, i);
  };
}
function Qc(e) {
  return Kc(e, pu, Yc);
}
function Xe(e, t) {
  var n = e.__data__;
  return nu(t) ? n[typeof t == "string" ? "string" : "hash"] : n.map;
}
function Ar(e, t) {
  var n = yc(e, t);
  return Wc(n) ? n : void 0;
}
var Zc = yt ? Sr(yt, Object) : xr, Yc = yt ? function(e) {
  for (var t = []; e; )
    Dt(t, Zc(e)), e = Oc(e);
  return t;
} : xr;
function eu(e) {
  return It(e) || $r(e) || !!(bn && e && e[bn]);
}
function tu(e, t) {
  return t = t ?? wr, !!t && (typeof e == "number" || sc.test(e)) && e > -1 && e % 1 == 0 && e < t;
}
function nu(e) {
  var t = typeof e;
  return t == "string" || t == "number" || t == "symbol" || t == "boolean" ? e !== "__proto__" : e === null;
}
function ru(e) {
  return !!En && En in e;
}
function ou(e) {
  var t = e && e.constructor, n = typeof t == "function" && t.prototype || Je;
  return e === n;
}
function su(e) {
  var t = [];
  if (e != null)
    for (var n in Object(e))
      t.push(n);
  return t;
}
function iu(e) {
  if (typeof e == "string" || fu(e))
    return e;
  var t = e + "";
  return t == "0" && 1 / e == -Za ? "-0" : t;
}
function au(e) {
  if (e != null) {
    try {
      return Tr.call(e);
    } catch {
    }
    try {
      return e + "";
    } catch {
    }
  }
  return "";
}
function cu(e, t) {
  return e === t || e !== e && t !== t;
}
function $r(e) {
  return uu(e) && ce.call(e, "callee") && (!wc.call(e, "callee") || Lt.call(e) == Ya);
}
var It = Array.isArray;
function Nr(e) {
  return e != null && lu(e.length) && !Pr(e);
}
function uu(e) {
  return jr(e) && Nr(e);
}
function Pr(e) {
  var t = Mt(e) ? Lt.call(e) : "";
  return t == ec || t == tc;
}
function lu(e) {
  return typeof e == "number" && e > -1 && e % 1 == 0 && e <= wr;
}
function Mt(e) {
  var t = typeof e;
  return !!e && (t == "object" || t == "function");
}
function jr(e) {
  return !!e && typeof e == "object";
}
function fu(e) {
  return typeof e == "symbol" || jr(e) && Lt.call(e) == nc;
}
function pu(e) {
  return Nr(e) ? Gc(e, !0) : zc(e);
}
var hu = Xc(function(e, t) {
  return e == null ? {} : (t = vr(Cr(t, 1), iu), Jc(e, qc(Qc(e), t)));
});
function xr() {
  return [];
}
var du = hu;
const mu = /* @__PURE__ */ Or(du);
var gu = "Expected a function", Fr = "__lodash_hash_undefined__", Ur = 1 / 0, yu = "[object Function]", Eu = "[object GeneratorFunction]", _u = "[object Symbol]", bu = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, Ru = /^\w*$/, Ou = /^\./, wu = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g, vu = /[\\^$.*+?()[\]{}|]/g, Su = /\\(\\)?/g, Tu = /^\[object .+?Constructor\]$/, Cu = typeof G == "object" && G && G.Object === Object && G, Au = typeof self == "object" && self && self.Object === Object && self, kt = Cu || Au || Function("return this")();
function $u(e, t) {
  return e == null ? void 0 : e[t];
}
function Nu(e) {
  var t = !1;
  if (e != null && typeof e.toString != "function")
    try {
      t = !!(e + "");
    } catch {
    }
  return t;
}
var Pu = Array.prototype, ju = Function.prototype, Br = Object.prototype, ft = kt["__core-js_shared__"], On = function() {
  var e = /[^.]+$/.exec(ft && ft.keys && ft.keys.IE_PROTO || "");
  return e ? "Symbol(src)_1." + e : "";
}(), Dr = ju.toString, Ht = Br.hasOwnProperty, Lr = Br.toString, xu = RegExp(
  "^" + Dr.call(Ht).replace(vu, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"
), wn = kt.Symbol, Fu = Pu.splice, Uu = Ir(kt, "Map"), Se = Ir(Object, "create"), vn = wn ? wn.prototype : void 0, Sn = vn ? vn.toString : void 0;
function V(e) {
  var t = -1, n = e ? e.length : 0;
  for (this.clear(); ++t < n; ) {
    var r = e[t];
    this.set(r[0], r[1]);
  }
}
function Bu() {
  this.__data__ = Se ? Se(null) : {};
}
function Du(e) {
  return this.has(e) && delete this.__data__[e];
}
function Lu(e) {
  var t = this.__data__;
  if (Se) {
    var n = t[e];
    return n === Fr ? void 0 : n;
  }
  return Ht.call(t, e) ? t[e] : void 0;
}
function Iu(e) {
  var t = this.__data__;
  return Se ? t[e] !== void 0 : Ht.call(t, e);
}
function Mu(e, t) {
  var n = this.__data__;
  return n[e] = Se && t === void 0 ? Fr : t, this;
}
V.prototype.clear = Bu;
V.prototype.delete = Du;
V.prototype.get = Lu;
V.prototype.has = Iu;
V.prototype.set = Mu;
function fe(e) {
  var t = -1, n = e ? e.length : 0;
  for (this.clear(); ++t < n; ) {
    var r = e[t];
    this.set(r[0], r[1]);
  }
}
function ku() {
  this.__data__ = [];
}
function Hu(e) {
  var t = this.__data__, n = Qe(t, e);
  if (n < 0)
    return !1;
  var r = t.length - 1;
  return n == r ? t.pop() : Fu.call(t, n, 1), !0;
}
function Gu(e) {
  var t = this.__data__, n = Qe(t, e);
  return n < 0 ? void 0 : t[n][1];
}
function qu(e) {
  return Qe(this.__data__, e) > -1;
}
function Ku(e, t) {
  var n = this.__data__, r = Qe(n, e);
  return r < 0 ? n.push([e, t]) : n[r][1] = t, this;
}
fe.prototype.clear = ku;
fe.prototype.delete = Hu;
fe.prototype.get = Gu;
fe.prototype.has = qu;
fe.prototype.set = Ku;
function Q(e) {
  var t = -1, n = e ? e.length : 0;
  for (this.clear(); ++t < n; ) {
    var r = e[t];
    this.set(r[0], r[1]);
  }
}
function Wu() {
  this.__data__ = {
    hash: new V(),
    map: new (Uu || fe)(),
    string: new V()
  };
}
function zu(e) {
  return Ze(this, e).delete(e);
}
function Ju(e) {
  return Ze(this, e).get(e);
}
function Vu(e) {
  return Ze(this, e).has(e);
}
function Xu(e, t) {
  return Ze(this, e).set(e, t), this;
}
Q.prototype.clear = Wu;
Q.prototype.delete = zu;
Q.prototype.get = Ju;
Q.prototype.has = Vu;
Q.prototype.set = Xu;
function Qe(e, t) {
  for (var n = e.length; n--; )
    if (al(e[n][0], t))
      return n;
  return -1;
}
function Qu(e, t) {
  t = tl(t, e) ? [t] : el(t);
  for (var n = 0, r = t.length; e != null && n < r; )
    e = e[sl(t[n++])];
  return n && n == r ? e : void 0;
}
function Zu(e) {
  if (!kr(e) || rl(e))
    return !1;
  var t = cl(e) || Nu(e) ? xu : Tu;
  return t.test(il(e));
}
function Yu(e) {
  if (typeof e == "string")
    return e;
  if (qt(e))
    return Sn ? Sn.call(e) : "";
  var t = e + "";
  return t == "0" && 1 / e == -Ur ? "-0" : t;
}
function el(e) {
  return Mr(e) ? e : ol(e);
}
function Ze(e, t) {
  var n = e.__data__;
  return nl(t) ? n[typeof t == "string" ? "string" : "hash"] : n.map;
}
function Ir(e, t) {
  var n = $u(e, t);
  return Zu(n) ? n : void 0;
}
function tl(e, t) {
  if (Mr(e))
    return !1;
  var n = typeof e;
  return n == "number" || n == "symbol" || n == "boolean" || e == null || qt(e) ? !0 : Ru.test(e) || !bu.test(e) || t != null && e in Object(t);
}
function nl(e) {
  var t = typeof e;
  return t == "string" || t == "number" || t == "symbol" || t == "boolean" ? e !== "__proto__" : e === null;
}
function rl(e) {
  return !!On && On in e;
}
var ol = Gt(function(e) {
  e = ll(e);
  var t = [];
  return Ou.test(e) && t.push(""), e.replace(wu, function(n, r, o, s) {
    t.push(o ? s.replace(Su, "$1") : r || n);
  }), t;
});
function sl(e) {
  if (typeof e == "string" || qt(e))
    return e;
  var t = e + "";
  return t == "0" && 1 / e == -Ur ? "-0" : t;
}
function il(e) {
  if (e != null) {
    try {
      return Dr.call(e);
    } catch {
    }
    try {
      return e + "";
    } catch {
    }
  }
  return "";
}
function Gt(e, t) {
  if (typeof e != "function" || t && typeof t != "function")
    throw new TypeError(gu);
  var n = function() {
    var r = arguments, o = t ? t.apply(this, r) : r[0], s = n.cache;
    if (s.has(o))
      return s.get(o);
    var i = e.apply(this, r);
    return n.cache = s.set(o, i), i;
  };
  return n.cache = new (Gt.Cache || Q)(), n;
}
Gt.Cache = Q;
function al(e, t) {
  return e === t || e !== e && t !== t;
}
var Mr = Array.isArray;
function cl(e) {
  var t = kr(e) ? Lr.call(e) : "";
  return t == yu || t == Eu;
}
function kr(e) {
  var t = typeof e;
  return !!e && (t == "object" || t == "function");
}
function ul(e) {
  return !!e && typeof e == "object";
}
function qt(e) {
  return typeof e == "symbol" || ul(e) && Lr.call(e) == _u;
}
function ll(e) {
  return e == null ? "" : Yu(e);
}
function fl(e, t, n) {
  var r = e == null ? void 0 : Qu(e, t);
  return r === void 0 ? n : r;
}
var pl = fl;
const hl = /* @__PURE__ */ Or(pl), Hr = ({
  basePath: e,
  timeout: t,
  beforeRequest: n = (u) => u,
  networkSuccessCodeList: r,
  isSuccessNetworkCode: o = (u) => Array.isArray(r) ? r.includes(u) : u >= 200 && u < 300,
  instanceCreateConfig: s = {},
  axios: i,
  ...a
}) => {
  const u = i.create({
    baseURL: e,
    timeout: t,
    ...s,
    validateStatus: o
  });
  u.interceptors.request.use(n, (c) => {
    if (c instanceof re)
      return Promise.reject(c);
    const p = new be({
      code: M.REQUEST_ERROR,
      message: Ee(c) ?? "发起请求出错",
      cause: c
    });
    return Promise.reject(p);
  });
  const { request: f } = Xa({
    ...a,
    basePath: e,
    timeout: t,
    issue: ({ TIMEOUT: c, DEBUG: p, ...g }) => u({
      timeout: c,
      ...mu(g, ["BASE_PATH"])
    }).then((m) => mi(m, a, p)).catch((m) => {
      if (m instanceof re)
        return p && P(
          {
            stage: N.NETWORK_ERROR_ORIGIN,
            data: m
          },
          H.ERROR
        ), Promise.reject(m);
      const { response: h, request: y } = m;
      let d, b;
      h ? (d = h.status, b = h.statusText) : y ? (d = M.NO_RESPONSE, i.isAxiosError(m) ? m.message.includes("timeout of") ? (d = M.NO_RESPONSE_TIMEOUT, b = "请求超时") : hl(globalThis, "navigator.onLine") === !1 ? (d = M.NO_RESPONSE_OFFLINE, b = "网络未连接") : b = m.message : b = Ee(m) ?? "未响应") : (d = M.REQUEST_ERROR, b = Ee(m) ?? "发起请求出错");
      const E = new be({
        code: d,
        message: b,
        cause: m
      });
      return p && P(
        {
          stage: N.NETWORK_ERROR_PACK,
          data: E
        },
        H.ERROR
      ), Promise.reject(E);
    })
  });
  return f;
};
function Gr(e, t) {
  return function() {
    return e.apply(t, arguments);
  };
}
const { toString: dl } = Object.prototype, { getPrototypeOf: Kt } = Object, Ye = ((e) => (t) => {
  const n = dl.call(t);
  return e[n] || (e[n] = n.slice(8, -1).toLowerCase());
})(/* @__PURE__ */ Object.create(null)), x = (e) => (e = e.toLowerCase(), (t) => Ye(t) === e), et = (e) => (t) => typeof t === e, { isArray: pe } = Array, Te = et("undefined");
function ml(e) {
  return e !== null && !Te(e) && e.constructor !== null && !Te(e.constructor) && A(e.constructor.isBuffer) && e.constructor.isBuffer(e);
}
const qr = x("ArrayBuffer");
function gl(e) {
  let t;
  return typeof ArrayBuffer < "u" && ArrayBuffer.isView ? t = ArrayBuffer.isView(e) : t = e && e.buffer && qr(e.buffer), t;
}
const yl = et("string"), A = et("function"), Kr = et("number"), tt = (e) => e !== null && typeof e == "object", El = (e) => e === !0 || e === !1, je = (e) => {
  if (Ye(e) !== "object")
    return !1;
  const t = Kt(e);
  return (t === null || t === Object.prototype || Object.getPrototypeOf(t) === null) && !(Symbol.toStringTag in e) && !(Symbol.iterator in e);
}, _l = x("Date"), bl = x("File"), Rl = x("Blob"), Ol = x("FileList"), wl = (e) => tt(e) && A(e.pipe), vl = (e) => {
  let t;
  return e && (typeof FormData == "function" && e instanceof FormData || A(e.append) && ((t = Ye(e)) === "formdata" || // detect form-data instance
  t === "object" && A(e.toString) && e.toString() === "[object FormData]"));
}, Sl = x("URLSearchParams"), [Tl, Cl, Al, $l] = ["ReadableStream", "Request", "Response", "Headers"].map(x), Nl = (e) => e.trim ? e.trim() : e.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g, "");
function $e(e, t, { allOwnKeys: n = !1 } = {}) {
  if (e === null || typeof e > "u")
    return;
  let r, o;
  if (typeof e != "object" && (e = [e]), pe(e))
    for (r = 0, o = e.length; r < o; r++)
      t.call(null, e[r], r, e);
  else {
    const s = n ? Object.getOwnPropertyNames(e) : Object.keys(e), i = s.length;
    let a;
    for (r = 0; r < i; r++)
      a = s[r], t.call(null, e[a], a, e);
  }
}
function Wr(e, t) {
  t = t.toLowerCase();
  const n = Object.keys(e);
  let r = n.length, o;
  for (; r-- > 0; )
    if (o = n[r], t === o.toLowerCase())
      return o;
  return null;
}
const q = (() => typeof globalThis < "u" ? globalThis : typeof self < "u" ? self : typeof window < "u" ? window : global)(), zr = (e) => !Te(e) && e !== q;
function Et() {
  const { caseless: e } = zr(this) && this || {}, t = {}, n = (r, o) => {
    const s = e && Wr(t, o) || o;
    je(t[s]) && je(r) ? t[s] = Et(t[s], r) : je(r) ? t[s] = Et({}, r) : pe(r) ? t[s] = r.slice() : t[s] = r;
  };
  for (let r = 0, o = arguments.length; r < o; r++)
    arguments[r] && $e(arguments[r], n);
  return t;
}
const Pl = (e, t, n, { allOwnKeys: r } = {}) => ($e(t, (o, s) => {
  n && A(o) ? e[s] = Gr(o, n) : e[s] = o;
}, { allOwnKeys: r }), e), jl = (e) => (e.charCodeAt(0) === 65279 && (e = e.slice(1)), e), xl = (e, t, n, r) => {
  e.prototype = Object.create(t.prototype, r), e.prototype.constructor = e, Object.defineProperty(e, "super", {
    value: t.prototype
  }), n && Object.assign(e.prototype, n);
}, Fl = (e, t, n, r) => {
  let o, s, i;
  const a = {};
  if (t = t || {}, e == null)
    return t;
  do {
    for (o = Object.getOwnPropertyNames(e), s = o.length; s-- > 0; )
      i = o[s], (!r || r(i, e, t)) && !a[i] && (t[i] = e[i], a[i] = !0);
    e = n !== !1 && Kt(e);
  } while (e && (!n || n(e, t)) && e !== Object.prototype);
  return t;
}, Ul = (e, t, n) => {
  e = String(e), (n === void 0 || n > e.length) && (n = e.length), n -= t.length;
  const r = e.indexOf(t, n);
  return r !== -1 && r === n;
}, Bl = (e) => {
  if (!e)
    return null;
  if (pe(e))
    return e;
  let t = e.length;
  if (!Kr(t))
    return null;
  const n = new Array(t);
  for (; t-- > 0; )
    n[t] = e[t];
  return n;
}, Dl = ((e) => (t) => e && t instanceof e)(typeof Uint8Array < "u" && Kt(Uint8Array)), Ll = (e, t) => {
  const r = (e && e[Symbol.iterator]).call(e);
  let o;
  for (; (o = r.next()) && !o.done; ) {
    const s = o.value;
    t.call(e, s[0], s[1]);
  }
}, Il = (e, t) => {
  let n;
  const r = [];
  for (; (n = e.exec(t)) !== null; )
    r.push(n);
  return r;
}, Ml = x("HTMLFormElement"), kl = (e) => e.toLowerCase().replace(
  /[-_\s]([a-z\d])(\w*)/g,
  function(n, r, o) {
    return r.toUpperCase() + o;
  }
), Tn = (({ hasOwnProperty: e }) => (t, n) => e.call(t, n))(Object.prototype), Hl = x("RegExp"), Jr = (e, t) => {
  const n = Object.getOwnPropertyDescriptors(e), r = {};
  $e(n, (o, s) => {
    let i;
    (i = t(o, s, e)) !== !1 && (r[s] = i || o);
  }), Object.defineProperties(e, r);
}, Gl = (e) => {
  Jr(e, (t, n) => {
    if (A(e) && ["arguments", "caller", "callee"].indexOf(n) !== -1)
      return !1;
    const r = e[n];
    if (A(r)) {
      if (t.enumerable = !1, "writable" in t) {
        t.writable = !1;
        return;
      }
      t.set || (t.set = () => {
        throw Error("Can not rewrite read-only method '" + n + "'");
      });
    }
  });
}, ql = (e, t) => {
  const n = {}, r = (o) => {
    o.forEach((s) => {
      n[s] = !0;
    });
  };
  return pe(e) ? r(e) : r(String(e).split(t)), n;
}, Kl = () => {
}, Wl = (e, t) => e != null && Number.isFinite(e = +e) ? e : t;
function zl(e) {
  return !!(e && A(e.append) && e[Symbol.toStringTag] === "FormData" && e[Symbol.iterator]);
}
const Jl = (e) => {
  const t = new Array(10), n = (r, o) => {
    if (tt(r)) {
      if (t.indexOf(r) >= 0)
        return;
      if (!("toJSON" in r)) {
        t[o] = r;
        const s = pe(r) ? [] : {};
        return $e(r, (i, a) => {
          const u = n(i, o + 1);
          !Te(u) && (s[a] = u);
        }), t[o] = void 0, s;
      }
    }
    return r;
  };
  return n(e, 0);
}, Vl = x("AsyncFunction"), Xl = (e) => e && (tt(e) || A(e)) && A(e.then) && A(e.catch), Vr = ((e, t) => e ? setImmediate : t ? ((n, r) => (q.addEventListener("message", ({ source: o, data: s }) => {
  o === q && s === n && r.length && r.shift()();
}, !1), (o) => {
  r.push(o), q.postMessage(n, "*");
}))(`axios@${Math.random()}`, []) : (n) => setTimeout(n))(
  typeof setImmediate == "function",
  A(q.postMessage)
), Ql = typeof queueMicrotask < "u" ? queueMicrotask.bind(q) : typeof process < "u" && process.nextTick || Vr, l = {
  isArray: pe,
  isArrayBuffer: qr,
  isBuffer: ml,
  isFormData: vl,
  isArrayBufferView: gl,
  isString: yl,
  isNumber: Kr,
  isBoolean: El,
  isObject: tt,
  isPlainObject: je,
  isReadableStream: Tl,
  isRequest: Cl,
  isResponse: Al,
  isHeaders: $l,
  isUndefined: Te,
  isDate: _l,
  isFile: bl,
  isBlob: Rl,
  isRegExp: Hl,
  isFunction: A,
  isStream: wl,
  isURLSearchParams: Sl,
  isTypedArray: Dl,
  isFileList: Ol,
  forEach: $e,
  merge: Et,
  extend: Pl,
  trim: Nl,
  stripBOM: jl,
  inherits: xl,
  toFlatObject: Fl,
  kindOf: Ye,
  kindOfTest: x,
  endsWith: Ul,
  toArray: Bl,
  forEachEntry: Ll,
  matchAll: Il,
  isHTMLForm: Ml,
  hasOwnProperty: Tn,
  hasOwnProp: Tn,
  // an alias to avoid ESLint no-prototype-builtins detection
  reduceDescriptors: Jr,
  freezeMethods: Gl,
  toObjectSet: ql,
  toCamelCase: kl,
  noop: Kl,
  toFiniteNumber: Wl,
  findKey: Wr,
  global: q,
  isContextDefined: zr,
  isSpecCompliantForm: zl,
  toJSONObject: Jl,
  isAsyncFn: Vl,
  isThenable: Xl,
  setImmediate: Vr,
  asap: Ql
};
function _(e, t, n, r, o) {
  Error.call(this), Error.captureStackTrace ? Error.captureStackTrace(this, this.constructor) : this.stack = new Error().stack, this.message = e, this.name = "AxiosError", t && (this.code = t), n && (this.config = n), r && (this.request = r), o && (this.response = o, this.status = o.status ? o.status : null);
}
l.inherits(_, Error, {
  toJSON: function() {
    return {
      // Standard
      message: this.message,
      name: this.name,
      // Microsoft
      description: this.description,
      number: this.number,
      // Mozilla
      fileName: this.fileName,
      lineNumber: this.lineNumber,
      columnNumber: this.columnNumber,
      stack: this.stack,
      // Axios
      config: l.toJSONObject(this.config),
      code: this.code,
      status: this.status
    };
  }
});
const Xr = _.prototype, Qr = {};
[
  "ERR_BAD_OPTION_VALUE",
  "ERR_BAD_OPTION",
  "ECONNABORTED",
  "ETIMEDOUT",
  "ERR_NETWORK",
  "ERR_FR_TOO_MANY_REDIRECTS",
  "ERR_DEPRECATED",
  "ERR_BAD_RESPONSE",
  "ERR_BAD_REQUEST",
  "ERR_CANCELED",
  "ERR_NOT_SUPPORT",
  "ERR_INVALID_URL"
  // eslint-disable-next-line func-names
].forEach((e) => {
  Qr[e] = { value: e };
});
Object.defineProperties(_, Qr);
Object.defineProperty(Xr, "isAxiosError", { value: !0 });
_.from = (e, t, n, r, o, s) => {
  const i = Object.create(Xr);
  return l.toFlatObject(e, i, function(u) {
    return u !== Error.prototype;
  }, (a) => a !== "isAxiosError"), _.call(i, e.message, t, n, r, o), i.cause = e, i.name = e.name, s && Object.assign(i, s), i;
};
const Zl = null;
function _t(e) {
  return l.isPlainObject(e) || l.isArray(e);
}
function Zr(e) {
  return l.endsWith(e, "[]") ? e.slice(0, -2) : e;
}
function Cn(e, t, n) {
  return e ? e.concat(t).map(function(o, s) {
    return o = Zr(o), !n && s ? "[" + o + "]" : o;
  }).join(n ? "." : "") : t;
}
function Yl(e) {
  return l.isArray(e) && !e.some(_t);
}
const ef = l.toFlatObject(l, {}, null, function(t) {
  return /^is[A-Z]/.test(t);
});
function nt(e, t, n) {
  if (!l.isObject(e))
    throw new TypeError("target must be an object");
  t = t || new FormData(), n = l.toFlatObject(n, {
    metaTokens: !0,
    dots: !1,
    indexes: !1
  }, !1, function(y, d) {
    return !l.isUndefined(d[y]);
  });
  const r = n.metaTokens, o = n.visitor || c, s = n.dots, i = n.indexes, u = (n.Blob || typeof Blob < "u" && Blob) && l.isSpecCompliantForm(t);
  if (!l.isFunction(o))
    throw new TypeError("visitor must be a function");
  function f(h) {
    if (h === null)
      return "";
    if (l.isDate(h))
      return h.toISOString();
    if (!u && l.isBlob(h))
      throw new _("Blob is not supported. Use a Buffer instead.");
    return l.isArrayBuffer(h) || l.isTypedArray(h) ? u && typeof Blob == "function" ? new Blob([h]) : Buffer.from(h) : h;
  }
  function c(h, y, d) {
    let b = h;
    if (h && !d && typeof h == "object") {
      if (l.endsWith(y, "{}"))
        y = r ? y : y.slice(0, -2), h = JSON.stringify(h);
      else if (l.isArray(h) && Yl(h) || (l.isFileList(h) || l.endsWith(y, "[]")) && (b = l.toArray(h)))
        return y = Zr(y), b.forEach(function(O, $) {
          !(l.isUndefined(O) || O === null) && t.append(
            // eslint-disable-next-line no-nested-ternary
            i === !0 ? Cn([y], $, s) : i === null ? y : y + "[]",
            f(O)
          );
        }), !1;
    }
    return _t(h) ? !0 : (t.append(Cn(d, y, s), f(h)), !1);
  }
  const p = [], g = Object.assign(ef, {
    defaultVisitor: c,
    convertValue: f,
    isVisitable: _t
  });
  function m(h, y) {
    if (!l.isUndefined(h)) {
      if (p.indexOf(h) !== -1)
        throw Error("Circular reference detected in " + y.join("."));
      p.push(h), l.forEach(h, function(b, E) {
        (!(l.isUndefined(b) || b === null) && o.call(
          t,
          b,
          l.isString(E) ? E.trim() : E,
          y,
          g
        )) === !0 && m(b, y ? y.concat(E) : [E]);
      }), p.pop();
    }
  }
  if (!l.isObject(e))
    throw new TypeError("data must be an object");
  return m(e), t;
}
function An(e) {
  const t = {
    "!": "%21",
    "'": "%27",
    "(": "%28",
    ")": "%29",
    "~": "%7E",
    "%20": "+",
    "%00": "\0"
  };
  return encodeURIComponent(e).replace(/[!'()~]|%20|%00/g, function(r) {
    return t[r];
  });
}
function Wt(e, t) {
  this._pairs = [], e && nt(e, this, t);
}
const Yr = Wt.prototype;
Yr.append = function(t, n) {
  this._pairs.push([t, n]);
};
Yr.toString = function(t) {
  const n = t ? function(r) {
    return t.call(this, r, An);
  } : An;
  return this._pairs.map(function(o) {
    return n(o[0]) + "=" + n(o[1]);
  }, "").join("&");
};
function tf(e) {
  return encodeURIComponent(e).replace(/%3A/gi, ":").replace(/%24/g, "$").replace(/%2C/gi, ",").replace(/%20/g, "+").replace(/%5B/gi, "[").replace(/%5D/gi, "]");
}
function eo(e, t, n) {
  if (!t)
    return e;
  const r = n && n.encode || tf;
  l.isFunction(n) && (n = {
    serialize: n
  });
  const o = n && n.serialize;
  let s;
  if (o ? s = o(t, n) : s = l.isURLSearchParams(t) ? t.toString() : new Wt(t, n).toString(r), s) {
    const i = e.indexOf("#");
    i !== -1 && (e = e.slice(0, i)), e += (e.indexOf("?") === -1 ? "?" : "&") + s;
  }
  return e;
}
class nf {
  constructor() {
    this.handlers = [];
  }
  /**
   * Add a new interceptor to the stack
   *
   * @param {Function} fulfilled The function to handle `then` for a `Promise`
   * @param {Function} rejected The function to handle `reject` for a `Promise`
   *
   * @return {Number} An ID used to remove interceptor later
   */
  use(t, n, r) {
    return this.handlers.push({
      fulfilled: t,
      rejected: n,
      synchronous: r ? r.synchronous : !1,
      runWhen: r ? r.runWhen : null
    }), this.handlers.length - 1;
  }
  /**
   * Remove an interceptor from the stack
   *
   * @param {Number} id The ID that was returned by `use`
   *
   * @returns {Boolean} `true` if the interceptor was removed, `false` otherwise
   */
  eject(t) {
    this.handlers[t] && (this.handlers[t] = null);
  }
  /**
   * Clear all interceptors from the stack
   *
   * @returns {void}
   */
  clear() {
    this.handlers && (this.handlers = []);
  }
  /**
   * Iterate over all the registered interceptors
   *
   * This method is particularly useful for skipping over any
   * interceptors that may have become `null` calling `eject`.
   *
   * @param {Function} fn The function to call for each interceptor
   *
   * @returns {void}
   */
  forEach(t) {
    l.forEach(this.handlers, function(r) {
      r !== null && t(r);
    });
  }
}
const $n = nf, to = {
  silentJSONParsing: !0,
  forcedJSONParsing: !0,
  clarifyTimeoutError: !1
}, rf = typeof URLSearchParams < "u" ? URLSearchParams : Wt, of = typeof FormData < "u" ? FormData : null, sf = typeof Blob < "u" ? Blob : null, af = {
  isBrowser: !0,
  classes: {
    URLSearchParams: rf,
    FormData: of,
    Blob: sf
  },
  protocols: ["http", "https", "file", "blob", "url", "data"]
}, zt = typeof window < "u" && typeof document < "u", bt = typeof navigator == "object" && navigator || void 0, cf = zt && (!bt || ["ReactNative", "NativeScript", "NS"].indexOf(bt.product) < 0), uf = (() => typeof WorkerGlobalScope < "u" && // eslint-disable-next-line no-undef
self instanceof WorkerGlobalScope && typeof self.importScripts == "function")(), lf = zt && window.location.href || "http://localhost", ff = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  hasBrowserEnv: zt,
  hasStandardBrowserEnv: cf,
  hasStandardBrowserWebWorkerEnv: uf,
  navigator: bt,
  origin: lf
}, Symbol.toStringTag, { value: "Module" })), T = {
  ...ff,
  ...af
};
function pf(e, t) {
  return nt(e, new T.classes.URLSearchParams(), Object.assign({
    visitor: function(n, r, o, s) {
      return T.isNode && l.isBuffer(n) ? (this.append(r, n.toString("base64")), !1) : s.defaultVisitor.apply(this, arguments);
    }
  }, t));
}
function hf(e) {
  return l.matchAll(/\w+|\[(\w*)]/g, e).map((t) => t[0] === "[]" ? "" : t[1] || t[0]);
}
function df(e) {
  const t = {}, n = Object.keys(e);
  let r;
  const o = n.length;
  let s;
  for (r = 0; r < o; r++)
    s = n[r], t[s] = e[s];
  return t;
}
function no(e) {
  function t(n, r, o, s) {
    let i = n[s++];
    if (i === "__proto__")
      return !0;
    const a = Number.isFinite(+i), u = s >= n.length;
    return i = !i && l.isArray(o) ? o.length : i, u ? (l.hasOwnProp(o, i) ? o[i] = [o[i], r] : o[i] = r, !a) : ((!o[i] || !l.isObject(o[i])) && (o[i] = []), t(n, r, o[i], s) && l.isArray(o[i]) && (o[i] = df(o[i])), !a);
  }
  if (l.isFormData(e) && l.isFunction(e.entries)) {
    const n = {};
    return l.forEachEntry(e, (r, o) => {
      t(hf(r), o, n, 0);
    }), n;
  }
  return null;
}
function mf(e, t, n) {
  if (l.isString(e))
    try {
      return (t || JSON.parse)(e), l.trim(e);
    } catch (r) {
      if (r.name !== "SyntaxError")
        throw r;
    }
  return (n || JSON.stringify)(e);
}
const Jt = {
  transitional: to,
  adapter: ["xhr", "http", "fetch"],
  transformRequest: [function(t, n) {
    const r = n.getContentType() || "", o = r.indexOf("application/json") > -1, s = l.isObject(t);
    if (s && l.isHTMLForm(t) && (t = new FormData(t)), l.isFormData(t))
      return o ? JSON.stringify(no(t)) : t;
    if (l.isArrayBuffer(t) || l.isBuffer(t) || l.isStream(t) || l.isFile(t) || l.isBlob(t) || l.isReadableStream(t))
      return t;
    if (l.isArrayBufferView(t))
      return t.buffer;
    if (l.isURLSearchParams(t))
      return n.setContentType("application/x-www-form-urlencoded;charset=utf-8", !1), t.toString();
    let a;
    if (s) {
      if (r.indexOf("application/x-www-form-urlencoded") > -1)
        return pf(t, this.formSerializer).toString();
      if ((a = l.isFileList(t)) || r.indexOf("multipart/form-data") > -1) {
        const u = this.env && this.env.FormData;
        return nt(
          a ? { "files[]": t } : t,
          u && new u(),
          this.formSerializer
        );
      }
    }
    return s || o ? (n.setContentType("application/json", !1), mf(t)) : t;
  }],
  transformResponse: [function(t) {
    const n = this.transitional || Jt.transitional, r = n && n.forcedJSONParsing, o = this.responseType === "json";
    if (l.isResponse(t) || l.isReadableStream(t))
      return t;
    if (t && l.isString(t) && (r && !this.responseType || o)) {
      const i = !(n && n.silentJSONParsing) && o;
      try {
        return JSON.parse(t);
      } catch (a) {
        if (i)
          throw a.name === "SyntaxError" ? _.from(a, _.ERR_BAD_RESPONSE, this, null, this.response) : a;
      }
    }
    return t;
  }],
  /**
   * A timeout in milliseconds to abort a request. If set to 0 (default) a
   * timeout is not created.
   */
  timeout: 0,
  xsrfCookieName: "XSRF-TOKEN",
  xsrfHeaderName: "X-XSRF-TOKEN",
  maxContentLength: -1,
  maxBodyLength: -1,
  env: {
    FormData: T.classes.FormData,
    Blob: T.classes.Blob
  },
  validateStatus: function(t) {
    return t >= 200 && t < 300;
  },
  headers: {
    common: {
      Accept: "application/json, text/plain, */*",
      "Content-Type": void 0
    }
  }
};
l.forEach(["delete", "get", "head", "post", "put", "patch"], (e) => {
  Jt.headers[e] = {};
});
const Vt = Jt, gf = l.toObjectSet([
  "age",
  "authorization",
  "content-length",
  "content-type",
  "etag",
  "expires",
  "from",
  "host",
  "if-modified-since",
  "if-unmodified-since",
  "last-modified",
  "location",
  "max-forwards",
  "proxy-authorization",
  "referer",
  "retry-after",
  "user-agent"
]), yf = (e) => {
  const t = {};
  let n, r, o;
  return e && e.split(`
`).forEach(function(i) {
    o = i.indexOf(":"), n = i.substring(0, o).trim().toLowerCase(), r = i.substring(o + 1).trim(), !(!n || t[n] && gf[n]) && (n === "set-cookie" ? t[n] ? t[n].push(r) : t[n] = [r] : t[n] = t[n] ? t[n] + ", " + r : r);
  }), t;
}, Nn = Symbol("internals");
function de(e) {
  return e && String(e).trim().toLowerCase();
}
function xe(e) {
  return e === !1 || e == null ? e : l.isArray(e) ? e.map(xe) : String(e);
}
function Ef(e) {
  const t = /* @__PURE__ */ Object.create(null), n = /([^\s,;=]+)\s*(?:=\s*([^,;]+))?/g;
  let r;
  for (; r = n.exec(e); )
    t[r[1]] = r[2];
  return t;
}
const _f = (e) => /^[-_a-zA-Z0-9^`|~,!#$%&'*+.]+$/.test(e.trim());
function pt(e, t, n, r, o) {
  if (l.isFunction(r))
    return r.call(this, t, n);
  if (o && (t = n), !!l.isString(t)) {
    if (l.isString(r))
      return t.indexOf(r) !== -1;
    if (l.isRegExp(r))
      return r.test(t);
  }
}
function bf(e) {
  return e.trim().toLowerCase().replace(/([a-z\d])(\w*)/g, (t, n, r) => n.toUpperCase() + r);
}
function Rf(e, t) {
  const n = l.toCamelCase(" " + t);
  ["get", "set", "has"].forEach((r) => {
    Object.defineProperty(e, r + n, {
      value: function(o, s, i) {
        return this[r].call(this, t, o, s, i);
      },
      configurable: !0
    });
  });
}
class rt {
  constructor(t) {
    t && this.set(t);
  }
  set(t, n, r) {
    const o = this;
    function s(a, u, f) {
      const c = de(u);
      if (!c)
        throw new Error("header name must be a non-empty string");
      const p = l.findKey(o, c);
      (!p || o[p] === void 0 || f === !0 || f === void 0 && o[p] !== !1) && (o[p || u] = xe(a));
    }
    const i = (a, u) => l.forEach(a, (f, c) => s(f, c, u));
    if (l.isPlainObject(t) || t instanceof this.constructor)
      i(t, n);
    else if (l.isString(t) && (t = t.trim()) && !_f(t))
      i(yf(t), n);
    else if (l.isHeaders(t))
      for (const [a, u] of t.entries())
        s(u, a, r);
    else
      t != null && s(n, t, r);
    return this;
  }
  get(t, n) {
    if (t = de(t), t) {
      const r = l.findKey(this, t);
      if (r) {
        const o = this[r];
        if (!n)
          return o;
        if (n === !0)
          return Ef(o);
        if (l.isFunction(n))
          return n.call(this, o, r);
        if (l.isRegExp(n))
          return n.exec(o);
        throw new TypeError("parser must be boolean|regexp|function");
      }
    }
  }
  has(t, n) {
    if (t = de(t), t) {
      const r = l.findKey(this, t);
      return !!(r && this[r] !== void 0 && (!n || pt(this, this[r], r, n)));
    }
    return !1;
  }
  delete(t, n) {
    const r = this;
    let o = !1;
    function s(i) {
      if (i = de(i), i) {
        const a = l.findKey(r, i);
        a && (!n || pt(r, r[a], a, n)) && (delete r[a], o = !0);
      }
    }
    return l.isArray(t) ? t.forEach(s) : s(t), o;
  }
  clear(t) {
    const n = Object.keys(this);
    let r = n.length, o = !1;
    for (; r--; ) {
      const s = n[r];
      (!t || pt(this, this[s], s, t, !0)) && (delete this[s], o = !0);
    }
    return o;
  }
  normalize(t) {
    const n = this, r = {};
    return l.forEach(this, (o, s) => {
      const i = l.findKey(r, s);
      if (i) {
        n[i] = xe(o), delete n[s];
        return;
      }
      const a = t ? bf(s) : String(s).trim();
      a !== s && delete n[s], n[a] = xe(o), r[a] = !0;
    }), this;
  }
  concat(...t) {
    return this.constructor.concat(this, ...t);
  }
  toJSON(t) {
    const n = /* @__PURE__ */ Object.create(null);
    return l.forEach(this, (r, o) => {
      r != null && r !== !1 && (n[o] = t && l.isArray(r) ? r.join(", ") : r);
    }), n;
  }
  [Symbol.iterator]() {
    return Object.entries(this.toJSON())[Symbol.iterator]();
  }
  toString() {
    return Object.entries(this.toJSON()).map(([t, n]) => t + ": " + n).join(`
`);
  }
  get [Symbol.toStringTag]() {
    return "AxiosHeaders";
  }
  static from(t) {
    return t instanceof this ? t : new this(t);
  }
  static concat(t, ...n) {
    const r = new this(t);
    return n.forEach((o) => r.set(o)), r;
  }
  static accessor(t) {
    const r = (this[Nn] = this[Nn] = {
      accessors: {}
    }).accessors, o = this.prototype;
    function s(i) {
      const a = de(i);
      r[a] || (Rf(o, i), r[a] = !0);
    }
    return l.isArray(t) ? t.forEach(s) : s(t), this;
  }
}
rt.accessor(["Content-Type", "Content-Length", "Accept", "Accept-Encoding", "User-Agent", "Authorization"]);
l.reduceDescriptors(rt.prototype, ({ value: e }, t) => {
  let n = t[0].toUpperCase() + t.slice(1);
  return {
    get: () => e,
    set(r) {
      this[n] = r;
    }
  };
});
l.freezeMethods(rt);
const j = rt;
function ht(e, t) {
  const n = this || Vt, r = t || n, o = j.from(r.headers);
  let s = r.data;
  return l.forEach(e, function(a) {
    s = a.call(n, s, o.normalize(), t ? t.status : void 0);
  }), o.normalize(), s;
}
function ro(e) {
  return !!(e && e.__CANCEL__);
}
function he(e, t, n) {
  _.call(this, e ?? "canceled", _.ERR_CANCELED, t, n), this.name = "CanceledError";
}
l.inherits(he, _, {
  __CANCEL__: !0
});
function oo(e, t, n) {
  const r = n.config.validateStatus;
  !n.status || !r || r(n.status) ? e(n) : t(new _(
    "Request failed with status code " + n.status,
    [_.ERR_BAD_REQUEST, _.ERR_BAD_RESPONSE][Math.floor(n.status / 100) - 4],
    n.config,
    n.request,
    n
  ));
}
function Of(e) {
  const t = /^([-+\w]{1,25})(:?\/\/|:)/.exec(e);
  return t && t[1] || "";
}
function wf(e, t) {
  e = e || 10;
  const n = new Array(e), r = new Array(e);
  let o = 0, s = 0, i;
  return t = t !== void 0 ? t : 1e3, function(u) {
    const f = Date.now(), c = r[s];
    i || (i = f), n[o] = u, r[o] = f;
    let p = s, g = 0;
    for (; p !== o; )
      g += n[p++], p = p % e;
    if (o = (o + 1) % e, o === s && (s = (s + 1) % e), f - i < t)
      return;
    const m = c && f - c;
    return m ? Math.round(g * 1e3 / m) : void 0;
  };
}
function vf(e, t) {
  let n = 0, r = 1e3 / t, o, s;
  const i = (f, c = Date.now()) => {
    n = c, o = null, s && (clearTimeout(s), s = null), e.apply(null, f);
  };
  return [(...f) => {
    const c = Date.now(), p = c - n;
    p >= r ? i(f, c) : (o = f, s || (s = setTimeout(() => {
      s = null, i(o);
    }, r - p)));
  }, () => o && i(o)];
}
const Ie = (e, t, n = 3) => {
  let r = 0;
  const o = wf(50, 250);
  return vf((s) => {
    const i = s.loaded, a = s.lengthComputable ? s.total : void 0, u = i - r, f = o(u), c = i <= a;
    r = i;
    const p = {
      loaded: i,
      total: a,
      progress: a ? i / a : void 0,
      bytes: u,
      rate: f || void 0,
      estimated: f && a && c ? (a - i) / f : void 0,
      event: s,
      lengthComputable: a != null,
      [t ? "download" : "upload"]: !0
    };
    e(p);
  }, n);
}, Pn = (e, t) => {
  const n = e != null;
  return [(r) => t[0]({
    lengthComputable: n,
    total: e,
    loaded: r
  }), t[1]];
}, jn = (e) => (...t) => l.asap(() => e(...t)), Sf = T.hasStandardBrowserEnv ? ((e, t) => (n) => (n = new URL(n, T.origin), e.protocol === n.protocol && e.host === n.host && (t || e.port === n.port)))(
  new URL(T.origin),
  T.navigator && /(msie|trident)/i.test(T.navigator.userAgent)
) : () => !0, Tf = T.hasStandardBrowserEnv ? (
  // Standard browser envs support document.cookie
  {
    write(e, t, n, r, o, s) {
      const i = [e + "=" + encodeURIComponent(t)];
      l.isNumber(n) && i.push("expires=" + new Date(n).toGMTString()), l.isString(r) && i.push("path=" + r), l.isString(o) && i.push("domain=" + o), s === !0 && i.push("secure"), document.cookie = i.join("; ");
    },
    read(e) {
      const t = document.cookie.match(new RegExp("(^|;\\s*)(" + e + ")=([^;]*)"));
      return t ? decodeURIComponent(t[3]) : null;
    },
    remove(e) {
      this.write(e, "", Date.now() - 864e5);
    }
  }
) : (
  // Non-standard browser env (web workers, react-native) lack needed support.
  {
    write() {
    },
    read() {
      return null;
    },
    remove() {
    }
  }
);
function Cf(e) {
  return /^([a-z][a-z\d+\-.]*:)?\/\//i.test(e);
}
function Af(e, t) {
  return t ? e.replace(/\/?\/$/, "") + "/" + t.replace(/^\/+/, "") : e;
}
function so(e, t, n) {
  let r = !Cf(t);
  return e && (r || n == !1) ? Af(e, t) : t;
}
const xn = (e) => e instanceof j ? { ...e } : e;
function X(e, t) {
  t = t || {};
  const n = {};
  function r(f, c, p, g) {
    return l.isPlainObject(f) && l.isPlainObject(c) ? l.merge.call({ caseless: g }, f, c) : l.isPlainObject(c) ? l.merge({}, c) : l.isArray(c) ? c.slice() : c;
  }
  function o(f, c, p, g) {
    if (l.isUndefined(c)) {
      if (!l.isUndefined(f))
        return r(void 0, f, p, g);
    } else
      return r(f, c, p, g);
  }
  function s(f, c) {
    if (!l.isUndefined(c))
      return r(void 0, c);
  }
  function i(f, c) {
    if (l.isUndefined(c)) {
      if (!l.isUndefined(f))
        return r(void 0, f);
    } else
      return r(void 0, c);
  }
  function a(f, c, p) {
    if (p in t)
      return r(f, c);
    if (p in e)
      return r(void 0, f);
  }
  const u = {
    url: s,
    method: s,
    data: s,
    baseURL: i,
    transformRequest: i,
    transformResponse: i,
    paramsSerializer: i,
    timeout: i,
    timeoutMessage: i,
    withCredentials: i,
    withXSRFToken: i,
    adapter: i,
    responseType: i,
    xsrfCookieName: i,
    xsrfHeaderName: i,
    onUploadProgress: i,
    onDownloadProgress: i,
    decompress: i,
    maxContentLength: i,
    maxBodyLength: i,
    beforeRedirect: i,
    transport: i,
    httpAgent: i,
    httpsAgent: i,
    cancelToken: i,
    socketPath: i,
    responseEncoding: i,
    validateStatus: a,
    headers: (f, c, p) => o(xn(f), xn(c), p, !0)
  };
  return l.forEach(Object.keys(Object.assign({}, e, t)), function(c) {
    const p = u[c] || o, g = p(e[c], t[c], c);
    l.isUndefined(g) && p !== a || (n[c] = g);
  }), n;
}
const io = (e) => {
  const t = X({}, e);
  let { data: n, withXSRFToken: r, xsrfHeaderName: o, xsrfCookieName: s, headers: i, auth: a } = t;
  t.headers = i = j.from(i), t.url = eo(so(t.baseURL, t.url, t.allowAbsoluteUrls), e.params, e.paramsSerializer), a && i.set(
    "Authorization",
    "Basic " + btoa((a.username || "") + ":" + (a.password ? unescape(encodeURIComponent(a.password)) : ""))
  );
  let u;
  if (l.isFormData(n)) {
    if (T.hasStandardBrowserEnv || T.hasStandardBrowserWebWorkerEnv)
      i.setContentType(void 0);
    else if ((u = i.getContentType()) !== !1) {
      const [f, ...c] = u ? u.split(";").map((p) => p.trim()).filter(Boolean) : [];
      i.setContentType([f || "multipart/form-data", ...c].join("; "));
    }
  }
  if (T.hasStandardBrowserEnv && (r && l.isFunction(r) && (r = r(t)), r || r !== !1 && Sf(t.url))) {
    const f = o && s && Tf.read(s);
    f && i.set(o, f);
  }
  return t;
}, $f = typeof XMLHttpRequest < "u", Nf = $f && function(e) {
  return new Promise(function(n, r) {
    const o = io(e);
    let s = o.data;
    const i = j.from(o.headers).normalize();
    let { responseType: a, onUploadProgress: u, onDownloadProgress: f } = o, c, p, g, m, h;
    function y() {
      m && m(), h && h(), o.cancelToken && o.cancelToken.unsubscribe(c), o.signal && o.signal.removeEventListener("abort", c);
    }
    let d = new XMLHttpRequest();
    d.open(o.method.toUpperCase(), o.url, !0), d.timeout = o.timeout;
    function b() {
      if (!d)
        return;
      const O = j.from(
        "getAllResponseHeaders" in d && d.getAllResponseHeaders()
      ), S = {
        data: !a || a === "text" || a === "json" ? d.responseText : d.response,
        status: d.status,
        statusText: d.statusText,
        headers: O,
        config: e,
        request: d
      };
      oo(function(U) {
        n(U), y();
      }, function(U) {
        r(U), y();
      }, S), d = null;
    }
    "onloadend" in d ? d.onloadend = b : d.onreadystatechange = function() {
      !d || d.readyState !== 4 || d.status === 0 && !(d.responseURL && d.responseURL.indexOf("file:") === 0) || setTimeout(b);
    }, d.onabort = function() {
      d && (r(new _("Request aborted", _.ECONNABORTED, e, d)), d = null);
    }, d.onerror = function() {
      r(new _("Network Error", _.ERR_NETWORK, e, d)), d = null;
    }, d.ontimeout = function() {
      let $ = o.timeout ? "timeout of " + o.timeout + "ms exceeded" : "timeout exceeded";
      const S = o.transitional || to;
      o.timeoutErrorMessage && ($ = o.timeoutErrorMessage), r(new _(
        $,
        S.clarifyTimeoutError ? _.ETIMEDOUT : _.ECONNABORTED,
        e,
        d
      )), d = null;
    }, s === void 0 && i.setContentType(null), "setRequestHeader" in d && l.forEach(i.toJSON(), function($, S) {
      d.setRequestHeader(S, $);
    }), l.isUndefined(o.withCredentials) || (d.withCredentials = !!o.withCredentials), a && a !== "json" && (d.responseType = o.responseType), f && ([g, h] = Ie(f, !0), d.addEventListener("progress", g)), u && d.upload && ([p, m] = Ie(u), d.upload.addEventListener("progress", p), d.upload.addEventListener("loadend", m)), (o.cancelToken || o.signal) && (c = (O) => {
      d && (r(!O || O.type ? new he(null, e, d) : O), d.abort(), d = null);
    }, o.cancelToken && o.cancelToken.subscribe(c), o.signal && (o.signal.aborted ? c() : o.signal.addEventListener("abort", c)));
    const E = Of(o.url);
    if (E && T.protocols.indexOf(E) === -1) {
      r(new _("Unsupported protocol " + E + ":", _.ERR_BAD_REQUEST, e));
      return;
    }
    d.send(s || null);
  });
}, Pf = (e, t) => {
  const { length: n } = e = e ? e.filter(Boolean) : [];
  if (t || n) {
    let r = new AbortController(), o;
    const s = function(f) {
      if (!o) {
        o = !0, a();
        const c = f instanceof Error ? f : this.reason;
        r.abort(c instanceof _ ? c : new he(c instanceof Error ? c.message : c));
      }
    };
    let i = t && setTimeout(() => {
      i = null, s(new _(`timeout ${t} of ms exceeded`, _.ETIMEDOUT));
    }, t);
    const a = () => {
      e && (i && clearTimeout(i), i = null, e.forEach((f) => {
        f.unsubscribe ? f.unsubscribe(s) : f.removeEventListener("abort", s);
      }), e = null);
    };
    e.forEach((f) => f.addEventListener("abort", s));
    const { signal: u } = r;
    return u.unsubscribe = () => l.asap(a), u;
  }
}, jf = Pf, xf = function* (e, t) {
  let n = e.byteLength;
  if (!t || n < t) {
    yield e;
    return;
  }
  let r = 0, o;
  for (; r < n; )
    o = r + t, yield e.slice(r, o), r = o;
}, Ff = async function* (e, t) {
  for await (const n of Uf(e))
    yield* xf(n, t);
}, Uf = async function* (e) {
  if (e[Symbol.asyncIterator]) {
    yield* e;
    return;
  }
  const t = e.getReader();
  try {
    for (; ; ) {
      const { done: n, value: r } = await t.read();
      if (n)
        break;
      yield r;
    }
  } finally {
    await t.cancel();
  }
}, Fn = (e, t, n, r) => {
  const o = Ff(e, t);
  let s = 0, i, a = (u) => {
    i || (i = !0, r && r(u));
  };
  return new ReadableStream({
    async pull(u) {
      try {
        const { done: f, value: c } = await o.next();
        if (f) {
          a(), u.close();
          return;
        }
        let p = c.byteLength;
        if (n) {
          let g = s += p;
          n(g);
        }
        u.enqueue(new Uint8Array(c));
      } catch (f) {
        throw a(f), f;
      }
    },
    cancel(u) {
      return a(u), o.return();
    }
  }, {
    highWaterMark: 2
  });
}, ot = typeof fetch == "function" && typeof Request == "function" && typeof Response == "function", ao = ot && typeof ReadableStream == "function", Bf = ot && (typeof TextEncoder == "function" ? ((e) => (t) => e.encode(t))(new TextEncoder()) : async (e) => new Uint8Array(await new Response(e).arrayBuffer())), co = (e, ...t) => {
  try {
    return !!e(...t);
  } catch {
    return !1;
  }
}, Df = ao && co(() => {
  let e = !1;
  const t = new Request(T.origin, {
    body: new ReadableStream(),
    method: "POST",
    get duplex() {
      return e = !0, "half";
    }
  }).headers.has("Content-Type");
  return e && !t;
}), Un = 64 * 1024, Rt = ao && co(() => l.isReadableStream(new Response("").body)), Me = {
  stream: Rt && ((e) => e.body)
};
ot && ((e) => {
  ["text", "arrayBuffer", "blob", "formData", "stream"].forEach((t) => {
    !Me[t] && (Me[t] = l.isFunction(e[t]) ? (n) => n[t]() : (n, r) => {
      throw new _(`Response type '${t}' is not supported`, _.ERR_NOT_SUPPORT, r);
    });
  });
})(new Response());
const Lf = async (e) => {
  if (e == null)
    return 0;
  if (l.isBlob(e))
    return e.size;
  if (l.isSpecCompliantForm(e))
    return (await new Request(T.origin, {
      method: "POST",
      body: e
    }).arrayBuffer()).byteLength;
  if (l.isArrayBufferView(e) || l.isArrayBuffer(e))
    return e.byteLength;
  if (l.isURLSearchParams(e) && (e = e + ""), l.isString(e))
    return (await Bf(e)).byteLength;
}, If = async (e, t) => {
  const n = l.toFiniteNumber(e.getContentLength());
  return n ?? Lf(t);
}, Mf = ot && (async (e) => {
  let {
    url: t,
    method: n,
    data: r,
    signal: o,
    cancelToken: s,
    timeout: i,
    onDownloadProgress: a,
    onUploadProgress: u,
    responseType: f,
    headers: c,
    withCredentials: p = "same-origin",
    fetchOptions: g
  } = io(e);
  f = f ? (f + "").toLowerCase() : "text";
  let m = jf([o, s && s.toAbortSignal()], i), h;
  const y = m && m.unsubscribe && (() => {
    m.unsubscribe();
  });
  let d;
  try {
    if (u && Df && n !== "get" && n !== "head" && (d = await If(c, r)) !== 0) {
      let S = new Request(t, {
        method: "POST",
        body: r,
        duplex: "half"
      }), F;
      if (l.isFormData(r) && (F = S.headers.get("content-type")) && c.setContentType(F), S.body) {
        const [U, I] = Pn(
          d,
          Ie(jn(u))
        );
        r = Fn(S.body, Un, U, I);
      }
    }
    l.isString(p) || (p = p ? "include" : "omit");
    const b = "credentials" in Request.prototype;
    h = new Request(t, {
      ...g,
      signal: m,
      method: n.toUpperCase(),
      headers: c.normalize().toJSON(),
      body: r,
      duplex: "half",
      credentials: b ? p : void 0
    });
    let E = await fetch(h);
    const O = Rt && (f === "stream" || f === "response");
    if (Rt && (a || O && y)) {
      const S = {};
      ["status", "statusText", "headers"].forEach((tn) => {
        S[tn] = E[tn];
      });
      const F = l.toFiniteNumber(E.headers.get("content-length")), [U, I] = a && Pn(
        F,
        Ie(jn(a), !0)
      ) || [];
      E = new Response(
        Fn(E.body, Un, U, () => {
          I && I(), y && y();
        }),
        S
      );
    }
    f = f || "text";
    let $ = await Me[l.findKey(Me, f) || "text"](E, e);
    return !O && y && y(), await new Promise((S, F) => {
      oo(S, F, {
        data: $,
        headers: j.from(E.headers),
        status: E.status,
        statusText: E.statusText,
        config: e,
        request: h
      });
    });
  } catch (b) {
    throw y && y(), b && b.name === "TypeError" && /fetch/i.test(b.message) ? Object.assign(
      new _("Network Error", _.ERR_NETWORK, e, h),
      {
        cause: b.cause || b
      }
    ) : _.from(b, b && b.code, e, h);
  }
}), Ot = {
  http: Zl,
  xhr: Nf,
  fetch: Mf
};
l.forEach(Ot, (e, t) => {
  if (e) {
    try {
      Object.defineProperty(e, "name", { value: t });
    } catch {
    }
    Object.defineProperty(e, "adapterName", { value: t });
  }
});
const Bn = (e) => `- ${e}`, kf = (e) => l.isFunction(e) || e === null || e === !1, uo = {
  getAdapter: (e) => {
    e = l.isArray(e) ? e : [e];
    const { length: t } = e;
    let n, r;
    const o = {};
    for (let s = 0; s < t; s++) {
      n = e[s];
      let i;
      if (r = n, !kf(n) && (r = Ot[(i = String(n)).toLowerCase()], r === void 0))
        throw new _(`Unknown adapter '${i}'`);
      if (r)
        break;
      o[i || "#" + s] = r;
    }
    if (!r) {
      const s = Object.entries(o).map(
        ([a, u]) => `adapter ${a} ` + (u === !1 ? "is not supported by the environment" : "is not available in the build")
      );
      let i = t ? s.length > 1 ? `since :
` + s.map(Bn).join(`
`) : " " + Bn(s[0]) : "as no adapter specified";
      throw new _(
        "There is no suitable adapter to dispatch the request " + i,
        "ERR_NOT_SUPPORT"
      );
    }
    return r;
  },
  adapters: Ot
};
function dt(e) {
  if (e.cancelToken && e.cancelToken.throwIfRequested(), e.signal && e.signal.aborted)
    throw new he(null, e);
}
function Dn(e) {
  return dt(e), e.headers = j.from(e.headers), e.data = ht.call(
    e,
    e.transformRequest
  ), ["post", "put", "patch"].indexOf(e.method) !== -1 && e.headers.setContentType("application/x-www-form-urlencoded", !1), uo.getAdapter(e.adapter || Vt.adapter)(e).then(function(r) {
    return dt(e), r.data = ht.call(
      e,
      e.transformResponse,
      r
    ), r.headers = j.from(r.headers), r;
  }, function(r) {
    return ro(r) || (dt(e), r && r.response && (r.response.data = ht.call(
      e,
      e.transformResponse,
      r.response
    ), r.response.headers = j.from(r.response.headers))), Promise.reject(r);
  });
}
const lo = "1.8.4", st = {};
["object", "boolean", "number", "function", "string", "symbol"].forEach((e, t) => {
  st[e] = function(r) {
    return typeof r === e || "a" + (t < 1 ? "n " : " ") + e;
  };
});
const Ln = {};
st.transitional = function(t, n, r) {
  function o(s, i) {
    return "[Axios v" + lo + "] Transitional option '" + s + "'" + i + (r ? ". " + r : "");
  }
  return (s, i, a) => {
    if (t === !1)
      throw new _(
        o(i, " has been removed" + (n ? " in " + n : "")),
        _.ERR_DEPRECATED
      );
    return n && !Ln[i] && (Ln[i] = !0, console.warn(
      o(
        i,
        " has been deprecated since v" + n + " and will be removed in the near future"
      )
    )), t ? t(s, i, a) : !0;
  };
};
st.spelling = function(t) {
  return (n, r) => (console.warn(`${r} is likely a misspelling of ${t}`), !0);
};
function Hf(e, t, n) {
  if (typeof e != "object")
    throw new _("options must be an object", _.ERR_BAD_OPTION_VALUE);
  const r = Object.keys(e);
  let o = r.length;
  for (; o-- > 0; ) {
    const s = r[o], i = t[s];
    if (i) {
      const a = e[s], u = a === void 0 || i(a, s, e);
      if (u !== !0)
        throw new _("option " + s + " must be " + u, _.ERR_BAD_OPTION_VALUE);
      continue;
    }
    if (n !== !0)
      throw new _("Unknown option " + s, _.ERR_BAD_OPTION);
  }
}
const Fe = {
  assertOptions: Hf,
  validators: st
}, B = Fe.validators;
class ke {
  constructor(t) {
    this.defaults = t, this.interceptors = {
      request: new $n(),
      response: new $n()
    };
  }
  /**
   * Dispatch a request
   *
   * @param {String|Object} configOrUrl The config specific for this request (merged with this.defaults)
   * @param {?Object} config
   *
   * @returns {Promise} The Promise to be fulfilled
   */
  async request(t, n) {
    try {
      return await this._request(t, n);
    } catch (r) {
      if (r instanceof Error) {
        let o = {};
        Error.captureStackTrace ? Error.captureStackTrace(o) : o = new Error();
        const s = o.stack ? o.stack.replace(/^.+\n/, "") : "";
        try {
          r.stack ? s && !String(r.stack).endsWith(s.replace(/^.+\n.+\n/, "")) && (r.stack += `
` + s) : r.stack = s;
        } catch {
        }
      }
      throw r;
    }
  }
  _request(t, n) {
    typeof t == "string" ? (n = n || {}, n.url = t) : n = t || {}, n = X(this.defaults, n);
    const { transitional: r, paramsSerializer: o, headers: s } = n;
    r !== void 0 && Fe.assertOptions(r, {
      silentJSONParsing: B.transitional(B.boolean),
      forcedJSONParsing: B.transitional(B.boolean),
      clarifyTimeoutError: B.transitional(B.boolean)
    }, !1), o != null && (l.isFunction(o) ? n.paramsSerializer = {
      serialize: o
    } : Fe.assertOptions(o, {
      encode: B.function,
      serialize: B.function
    }, !0)), n.allowAbsoluteUrls !== void 0 || (this.defaults.allowAbsoluteUrls !== void 0 ? n.allowAbsoluteUrls = this.defaults.allowAbsoluteUrls : n.allowAbsoluteUrls = !0), Fe.assertOptions(n, {
      baseUrl: B.spelling("baseURL"),
      withXsrfToken: B.spelling("withXSRFToken")
    }, !0), n.method = (n.method || this.defaults.method || "get").toLowerCase();
    let i = s && l.merge(
      s.common,
      s[n.method]
    );
    s && l.forEach(
      ["delete", "get", "head", "post", "put", "patch", "common"],
      (h) => {
        delete s[h];
      }
    ), n.headers = j.concat(i, s);
    const a = [];
    let u = !0;
    this.interceptors.request.forEach(function(y) {
      typeof y.runWhen == "function" && y.runWhen(n) === !1 || (u = u && y.synchronous, a.unshift(y.fulfilled, y.rejected));
    });
    const f = [];
    this.interceptors.response.forEach(function(y) {
      f.push(y.fulfilled, y.rejected);
    });
    let c, p = 0, g;
    if (!u) {
      const h = [Dn.bind(this), void 0];
      for (h.unshift.apply(h, a), h.push.apply(h, f), g = h.length, c = Promise.resolve(n); p < g; )
        c = c.then(h[p++], h[p++]);
      return c;
    }
    g = a.length;
    let m = n;
    for (p = 0; p < g; ) {
      const h = a[p++], y = a[p++];
      try {
        m = h(m);
      } catch (d) {
        y.call(this, d);
        break;
      }
    }
    try {
      c = Dn.call(this, m);
    } catch (h) {
      return Promise.reject(h);
    }
    for (p = 0, g = f.length; p < g; )
      c = c.then(f[p++], f[p++]);
    return c;
  }
  getUri(t) {
    t = X(this.defaults, t);
    const n = so(t.baseURL, t.url, t.allowAbsoluteUrls);
    return eo(n, t.params, t.paramsSerializer);
  }
}
l.forEach(["delete", "get", "head", "options"], function(t) {
  ke.prototype[t] = function(n, r) {
    return this.request(X(r || {}, {
      method: t,
      url: n,
      data: (r || {}).data
    }));
  };
});
l.forEach(["post", "put", "patch"], function(t) {
  function n(r) {
    return function(s, i, a) {
      return this.request(X(a || {}, {
        method: t,
        headers: r ? {
          "Content-Type": "multipart/form-data"
        } : {},
        url: s,
        data: i
      }));
    };
  }
  ke.prototype[t] = n(), ke.prototype[t + "Form"] = n(!0);
});
const Ue = ke;
class Xt {
  constructor(t) {
    if (typeof t != "function")
      throw new TypeError("executor must be a function.");
    let n;
    this.promise = new Promise(function(s) {
      n = s;
    });
    const r = this;
    this.promise.then((o) => {
      if (!r._listeners)
        return;
      let s = r._listeners.length;
      for (; s-- > 0; )
        r._listeners[s](o);
      r._listeners = null;
    }), this.promise.then = (o) => {
      let s;
      const i = new Promise((a) => {
        r.subscribe(a), s = a;
      }).then(o);
      return i.cancel = function() {
        r.unsubscribe(s);
      }, i;
    }, t(function(s, i, a) {
      r.reason || (r.reason = new he(s, i, a), n(r.reason));
    });
  }
  /**
   * Throws a `CanceledError` if cancellation has been requested.
   */
  throwIfRequested() {
    if (this.reason)
      throw this.reason;
  }
  /**
   * Subscribe to the cancel signal
   */
  subscribe(t) {
    if (this.reason) {
      t(this.reason);
      return;
    }
    this._listeners ? this._listeners.push(t) : this._listeners = [t];
  }
  /**
   * Unsubscribe from the cancel signal
   */
  unsubscribe(t) {
    if (!this._listeners)
      return;
    const n = this._listeners.indexOf(t);
    n !== -1 && this._listeners.splice(n, 1);
  }
  toAbortSignal() {
    const t = new AbortController(), n = (r) => {
      t.abort(r);
    };
    return this.subscribe(n), t.signal.unsubscribe = () => this.unsubscribe(n), t.signal;
  }
  /**
   * Returns an object that contains a new `CancelToken` and a function that, when called,
   * cancels the `CancelToken`.
   */
  static source() {
    let t;
    return {
      token: new Xt(function(o) {
        t = o;
      }),
      cancel: t
    };
  }
}
const Gf = Xt;
function qf(e) {
  return function(n) {
    return e.apply(null, n);
  };
}
function Kf(e) {
  return l.isObject(e) && e.isAxiosError === !0;
}
const wt = {
  Continue: 100,
  SwitchingProtocols: 101,
  Processing: 102,
  EarlyHints: 103,
  Ok: 200,
  Created: 201,
  Accepted: 202,
  NonAuthoritativeInformation: 203,
  NoContent: 204,
  ResetContent: 205,
  PartialContent: 206,
  MultiStatus: 207,
  AlreadyReported: 208,
  ImUsed: 226,
  MultipleChoices: 300,
  MovedPermanently: 301,
  Found: 302,
  SeeOther: 303,
  NotModified: 304,
  UseProxy: 305,
  Unused: 306,
  TemporaryRedirect: 307,
  PermanentRedirect: 308,
  BadRequest: 400,
  Unauthorized: 401,
  PaymentRequired: 402,
  Forbidden: 403,
  NotFound: 404,
  MethodNotAllowed: 405,
  NotAcceptable: 406,
  ProxyAuthenticationRequired: 407,
  RequestTimeout: 408,
  Conflict: 409,
  Gone: 410,
  LengthRequired: 411,
  PreconditionFailed: 412,
  PayloadTooLarge: 413,
  UriTooLong: 414,
  UnsupportedMediaType: 415,
  RangeNotSatisfiable: 416,
  ExpectationFailed: 417,
  ImATeapot: 418,
  MisdirectedRequest: 421,
  UnprocessableEntity: 422,
  Locked: 423,
  FailedDependency: 424,
  TooEarly: 425,
  UpgradeRequired: 426,
  PreconditionRequired: 428,
  TooManyRequests: 429,
  RequestHeaderFieldsTooLarge: 431,
  UnavailableForLegalReasons: 451,
  InternalServerError: 500,
  NotImplemented: 501,
  BadGateway: 502,
  ServiceUnavailable: 503,
  GatewayTimeout: 504,
  HttpVersionNotSupported: 505,
  VariantAlsoNegotiates: 506,
  InsufficientStorage: 507,
  LoopDetected: 508,
  NotExtended: 510,
  NetworkAuthenticationRequired: 511
};
Object.entries(wt).forEach(([e, t]) => {
  wt[t] = e;
});
const Wf = wt;
function fo(e) {
  const t = new Ue(e), n = Gr(Ue.prototype.request, t);
  return l.extend(n, Ue.prototype, t, { allOwnKeys: !0 }), l.extend(n, t, null, { allOwnKeys: !0 }), n.create = function(o) {
    return fo(X(e, o));
  }, n;
}
const w = fo(Vt);
w.Axios = Ue;
w.CanceledError = he;
w.CancelToken = Gf;
w.isCancel = ro;
w.VERSION = lo;
w.toFormData = nt;
w.AxiosError = _;
w.Cancel = w.CanceledError;
w.all = function(t) {
  return Promise.all(t);
};
w.spread = qf;
w.isAxiosError = Kf;
w.mergeConfig = X;
w.AxiosHeaders = j;
w.formToJSON = (e) => no(l.isHTMLForm(e) ? new FormData(e) : e);
w.getAdapter = uo.getAdapter;
w.HttpStatusCode = Wf;
w.default = w;
const zf = w;
var Z = /* @__PURE__ */ ((e) => (e.INIT = "init", e.CLONE = "clone", e.HOOKS = "hooks", e.CHECK = "check", e))(Z || {}), ne = /* @__PURE__ */ ((e) => (e.DEFAULT = "default", e.CLONE_CONFIG = "cloneConfig", e))(ne || {}), L = /* @__PURE__ */ ((e) => (e.GITHUB = "github", e.GITEE = "gitee", e))(L || {}), Ne = /* @__PURE__ */ ((e) => (e.REVERSE_MERGE = "reverseMerge", e))(Ne || {}), D = /* @__PURE__ */ ((e) => (e.REFLOG_ACTION = "reflog-action", e.COMMIT_MSG = "commit-msg", e.COMMIT_RECORD = "commit-record", e.PRE_REBASE = "pre-rebase", e))(D || {});
const Jf = 3e4, In = Math.random(), po = {
  timeout: Jf,
  getBusinessCode() {
    return In;
  },
  getBusinessMsg(e) {
    return e.statusText;
  },
  getBusinessData(e) {
    return e.data;
  },
  businessSuccessCodeList: [In],
  axios: zf
}, ho = Hr({
  basePath: " https://gitee.com",
  ...po
}), mo = Hr({
  basePath: "https://api.github.com",
  ...po
}), Vf = ({
  username: e
}) => ho({
  url: `/api/v5/users/${e}/repos`,
  method: "GET"
}), Xf = ({
  accessToken: e
}) => ho({
  url: "/api/v5/user/repos",
  method: "GET",
  params: {
    access_token: e,
    per_page: 100,
    page: 1,
    sort: "updated"
  }
}), Qf = ({
  username: e
}) => mo({
  url: `/users/${e}/repos`,
  method: "GET"
}), Zf = ({
  accessToken: e
}) => mo({
  url: "/user/repos",
  method: "GET",
  headers: {
    Authorization: `Bearer ${e}`
  },
  params: {
    per_page: 100,
    page: 1,
    sort: "updated"
  }
}), go = {
  name: "@done-coding/cli-git",
  version: "0.6.2",
  description: "git跨平台操作命令行工具",
  cliConfig: {
    namespaceDir: ".done-coding",
    moduleName: "git"
  }
}, {
  cliConfig: { namespaceDir: Yf, moduleName: ep }
} = go, yo = `./${Yf}/${ep}`, Qt = `${yo}.json`, Eo = (e) => `${yo}/.${e}`, _o = ({ platform: e, username: t }) => `${e}/${t}`, tp = (e) => {
  const { platform: t } = e, n = Eo(t), r = Hn(n, {
    isFindFarthest: !1
  });
  if (!r) {
    R.warn("配置文件不存在");
    return;
  }
  const o = `${r}/${n}`, s = mt.readFileSync(o, "utf-8"), i = _o(e), a = To({ encryptedText: s, secretKey: i });
  if (!a) {
    R.warn("配置文件解密失败");
    return;
  }
  return JSON.parse(a);
}, np = ({
  rootDir: e,
  username: t,
  platform: n,
  accessToken: r
}) => {
  const o = Eo(n), s = JSON.stringify({
    accessToken: r
  }), i = _o({ platform: n, username: t }), a = Co({ text: s, secretKey: i }), u = ye.join(e, o);
  mt.mkdirSync(ye.dirname(u), {
    recursive: !0
  }), mt.writeFileSync(u, a, "utf-8"), R.success(`配置信息保存成功 ${u}`);
}, Mn = [
  { title: "GitHub", value: L.GITHUB },
  { title: "Gitee", value: L.GITEE }
], Zt = (e) => {
  let t = 0;
  if (e) {
    const n = Mn.findIndex(
      (r) => r.value === e
    );
    n >= 0 && (t = n);
  }
  return {
    type: "select",
    name: "platform",
    message: "选择git平台",
    choices: Mn,
    initial: t
  };
}, Yt = (e) => ({
  type: "text",
  name: "username",
  message: "请输入用户名",
  format: (t) => t.trim(),
  validate: (t) => t.length > 0 || "用户名不能为空",
  initial: e
}), rp = {
  type: "password",
  name: "accessToken",
  message: "请输入git access token",
  format: (e) => e.trim(),
  validate: (e) => e.length > 0 || "access token不能为空"
}, op = async ({
  platform: e,
  username: t
} = {}) => {
  const n = {
    platform: e,
    username: t
  };
  e || (n.platform = (await C(Zt())).platform), t || (n.username = (await C(Yt())).username);
  const { platform: r, username: o } = n;
  let s = [];
  const i = tp({
    username: o,
    platform: r
  });
  let a = i == null ? void 0 : i.accessToken;
  R.stage(`正在获取${o}的${r}仓库列表...`);
  const u = {
    username: o,
    accessToken: a
  };
  switch (n.platform) {
    case L.GITHUB: {
      s = (await (u.accessToken ? Zf : Qf)(u)).data.map((c) => ({
        name: c.name,
        httpUrl: c.clone_url,
        sshUrl: c.ssh_url,
        description: c.description || ""
      }));
      break;
    }
    case L.GITEE: {
      s = (await (u.accessToken ? Xf : Vf)(u)).data.map((c) => ({
        name: c.name,
        httpUrl: c.html_url,
        sshUrl: c.ssh_url,
        description: c.description || ""
      }));
      break;
    }
    default:
      return R.error(`未知平台${r}`), process.exit(1);
  }
  if (R.success(`获取${o}的${r}仓库列表成功`), s.length === 0) {
    R.warn(`${o} 可获取${r}仓库列表为空`);
    return;
  } else
    R.stage(`共${s.length}个仓库`);
  const { repoUrl: f } = await C({
    name: "repoUrl",
    type: "select",
    message: "选择仓库",
    choices: s.map((c) => ({
      title: `${c.name} ${c.description}`,
      value: c.sshUrl
    }))
  });
  return f;
}, sp = [
  v.PRE_COMMIT,
  v.PRE_MERGE_COMMIT,
  v.PREPARE_COMMIT_MSG,
  v.COMMIT_MSG,
  v.PRE_REBASE,
  v.POST_COMMIT,
  v.POST_MERGE,
  v.PRE_PUSH
], ip = [
  v.PRE_MERGE_COMMIT,
  v.PREPARE_COMMIT_MSG,
  v.POST_MERGE,
  v.PRE_PUSH,
  v.PRE_REBASE
], it = (e) => {
  const {
    [Z.CHECK]: { [Ne.REVERSE_MERGE]: t }
  } = e;
  return t;
}, ap = (e) => Math.max(
  0,
  ...Object.values(e).map(({ logCount: t }) => t)
), cp = (e, t) => Object.entries(e).reduce(
  (n, [r, { afterHash: o, logCount: s }]) => {
    let i = s - 1;
    if (o) {
      const a = t.findIndex((u) => u.hash === o);
      a !== -1 && (R.info(
        `${r} 设置 只检测 ${o} 之后的日志 即 下标 [0 - ${a})`
      ), i = Math.min(i, a - 1));
    }
    return R.info(`${r} 最多检查${i + 1}条`), n[r] = i, n;
  },
  {}
), en = ({
  mergeInfo: e,
  configMap: t,
  currentBranch: n
}) => {
  if (!e)
    return;
  const { fromBranch: r, toBranch: o = n } = e;
  if (r === n) {
    R.skip(`跳过: 允许远程${r} => 本地${o}`);
    return;
  }
  const s = !!Object.keys(t).map(
    (i) => new RegExp(i)
  ).find(
    (i) => i.test(r)
  );
  return s || R.skip(`跳过: 允许${r} => ${o}`), s;
}, up = {
  [Z.CHECK]: {
    [Ne.REVERSE_MERGE]: {
      [/^test$/.source]: {
        includeRebase: !0,
        logCount: 10,
        afterHash: ""
      }
    }
  }
}, lp = () => ({
  ...vt({
    configPathDefault: Qt
  }),
  type: {
    alias: "t",
    describe: "初始化类型",
    choices: [ne.DEFAULT, ne.CLONE_CONFIG],
    default: ne.DEFAULT
  }
}), fp = (e) => {
  Y(`npm pkg set scripts.postprepare="${e} init"`);
}, pp = async (e) => {
  const { type: t } = e;
  switch (t) {
    case ne.DEFAULT: {
      const { rootDir: n, isSubCommand: r, _: o } = e, s = `${e.$0}${r ? ` ${o[0]}` : ""}`;
      return await vo({
        hookNames: ip,
        rootDir: n,
        getCode: (i) => `npx ${s} hooks ${i} "$@"`
      }), await fp(s), So(up, e, {
        onFileGenerated: (i) => {
          R.info(`文件生成成功: ${i}`);
        }
      });
    }
    case ne.CLONE_CONFIG: {
      const { rootDir: n } = e, { platform: r } = await C(Zt()), { username: o } = await C(Yt()), { accessToken: s } = await C(rp);
      return np({
        rootDir: n,
        platform: r,
        username: o,
        accessToken: s
      });
    }
    default:
      throw new Error(`未知的初始化类型: ${t}`);
  }
}, hp = {
  command: Z.INIT,
  describe: "初始化配置文件",
  options: lp(),
  handler: pp
}, dp = () => ({
  projectName: {
    type: "string",
    alias: "p",
    describe: "项目名称"
  }
}), mp = () => ({
  platform: {
    describe: "选择git平台",
    type: "string",
    choices: [L.GITHUB, L.GITEE]
  },
  username: {
    describe: "git平台用户名",
    type: "string"
  }
}), bo = async (e) => {
  const t = await op(e), { projectName: n } = e;
  Y(
    `git clone ${t} ${n ? `${n} ` : ""}--depth=1`,
    { stdio: "inherit" }
  ), R.success(`克隆${t}成功`);
}, gp = {
  command: `${Z.CLONE} <platform> <username>`,
  describe: "从选择的git平台克隆代码",
  options: dp(),
  positionals: mp(),
  handler: bo
}, yp = () => vt({
  configPathDefault: Qt
}), Ep = () => ({
  type: {
    describe: "检测类型",
    type: "string",
    choices: [Ne.REVERSE_MERGE]
  }
}), _p = ({
  config: e,
  currentBranch: t
}) => {
  const n = No();
  if (!n)
    return;
  const r = it(e), o = en({
    mergeInfo: n,
    configMap: r,
    currentBranch: t
  }), { fromBranch: s } = n;
  if (o) {
    const i = `发现当前执行 git ${process.env.GIT_REFLOG_ACTION}
意欲反向合并${s} 
拦截 !!!

--------- 建议 ---------
可以通过
1.查看当前已提交记录的最新版本号  
  git log  
2. 回退到当前已提交记录的最新版本
  git reset --hard <当前已提交记录的最新版本号> 
    `;
    return R.error(i), process.exit(1);
  }
}, bp = ({
  config: e,
  currentBranch: t,
  commitMsg: n,
  rootDir: r
}) => {
  if (Po(r))
    return R.skip("当前在变基中, 不通过提交信息检测合并");
  const o = jo(n), s = it(e);
  if (en({
    mergeInfo: o,
    configMap: s,
    currentBranch: t
  })) {
    const { fromBranch: i, toBranch: a = t } = o, u = `禁止${i}被合并: ${i} => ${a}

--------- 建议 ---------
可以通过
1.查看当前已提交记录的最新版本号  
  git log  
2. 回退到当前已提交记录的最新版本
  git reset --hard <当前已提交记录的最新版本号> 
        `;
    return R.error(u), process.exit(1);
  }
}, Rp = ({
  config: e,
  currentBranch: t
}) => {
  const n = it(e), r = ap(n);
  if (!r)
    return;
  const o = xo({ count: r }), s = cp(n, o), i = o.map((u) => u.hash), a = Fo({
    /** 考虑reflog存在往复切换  */
    count: r + 30,
    filterItem: (u) => i.includes(u.hash)
  }).reduce(
    (u, f) => (f.mergeInfo && (u[f.hash] = f), u),
    {}
  );
  o.forEach((u, f) => {
    var c;
    const p = u.mergeInfo || ((c = a[u.hash]) == null ? void 0 : c.mergeInfo);
    p && Object.entries(n).forEach(([g]) => {
      const m = s[g];
      if (f > m) {
        R.skip(`${g} 只检测${m + 1}条， 超出不再检测`);
        return;
      }
      const h = en({
        mergeInfo: p,
        configMap: n,
        currentBranch: t
      }), { fromBranch: y } = p;
      if (h) {
        const d = `发现${y}被合并
  本次提交版本 ${u.hash}
  提交注释 ${u.message}
  提交人: ${u.committer}
  提交时间: ${u.commitTime}

--------- 建议 ---------
可以通过
1.查看操作日志版本号为${u.hash}的前一次操作的版本号 
  git reflog
3. 回退到前一次操作的版本号 
  git reset --hard <当前已提交记录的最新版本号> 
`;
        return R.error(d), process.exit(1);
      }
    });
  });
}, Op = ({
  config: e,
  rebaseInfo: t
}) => {
  const n = it(e), r = Object.entries(n), { targetBranch: o, originBranch: s } = t;
  for (let [i, a] of r)
    if (a.includeRebase) {
      if (new RegExp(i).test(o)) {
        const u = `禁止变基到${o}的基线
    即 禁止${s}分子包含${o}分支(可能)存在的其他需求的代码`;
        return R.error(u), process.exit(1);
      }
    } else
      R.skip(`不检测是否变基到${o}的基线`);
  R.success(`允许变基到${o}`);
}, ge = async (e) => {
  const { config: t, way: n } = e, r = Ao();
  switch (n) {
    case D.REFLOG_ACTION: {
      _p({ config: t, currentBranch: r });
      break;
    }
    case D.COMMIT_MSG: {
      const { hookName: o, rootDir: s } = e, i = $o({
        hookName: o,
        rootDir: s
      });
      bp({
        config: t,
        currentBranch: r,
        commitMsg: i,
        rootDir: s
      });
      break;
    }
    case D.COMMIT_RECORD: {
      Rp({ config: t, currentBranch: r });
      break;
    }
    case D.PRE_REBASE: {
      const { args: o } = e, [
        s,
        /** 能进入 rebase 说明originBranch有值 或者 当前在某个分支上 */
        i = r
      ] = o;
      Op({
        config: t,
        rebaseInfo: {
          targetBranch: s,
          originBranch: i
        }
      });
      break;
    }
    default:
      throw new Error(`不支持的检测方式${n}`);
  }
}, wp = async (e) => {
  const t = await me(e), { type: n } = e;
  switch (n) {
    case Ne.REVERSE_MERGE: {
      await ge({
        rootDir: e.rootDir,
        config: t,
        way: D.COMMIT_RECORD
      });
      break;
    }
    default:
      throw new Error(`不支持的检测类型${n}`);
  }
}, vp = {
  command: `${Z.CHECK} <type>`,
  describe: "检查git操作",
  options: yp(),
  positionals: Ep(),
  handler: wp
}, Sp = () => vt({
  configPathDefault: Qt
}), Tp = () => ({
  name: {
    describe: "钩子名称",
    type: "string",
    choices: sp
  }
}), Cp = async (e) => {
  const { name: t, rootDir: n, args: r } = e;
  switch (t) {
    case v.PRE_MERGE_COMMIT: {
      const o = await me(e);
      ge({
        config: o,
        way: D.REFLOG_ACTION,
        rootDir: n
      });
      break;
    }
    case v.PREPARE_COMMIT_MSG: {
      const o = await me(e);
      ge({
        config: o,
        way: D.COMMIT_MSG,
        hookName: t,
        rootDir: n
      });
      break;
    }
    case v.POST_MERGE:
    case v.PRE_PUSH: {
      const o = await me(e);
      ge({
        config: o,
        way: D.COMMIT_RECORD,
        rootDir: n
      });
      break;
    }
    case v.PRE_REBASE: {
      const o = await me(e);
      ge({
        config: o,
        way: D.PRE_REBASE,
        args: r
      });
      break;
    }
    default:
      R.error(`${t} 当前未支持处理`);
  }
}, Ap = {
  command: `${Z.HOOKS} <name> [args...]`,
  describe: "git钩子回调",
  options: Sp(),
  positionals: Tp(),
  handler: Cp
}, { version: $p, description: Np } = go;
[
  hp,
  gp,
  Ap,
  vp
].map(kn);
const Pp = async (e) => {
  console.log("克隆done-coding系列项目"), console.log("选择平台:");
  const { platform: t } = await C(Zt(L.GITEE));
  console.log("选择用户名:");
  const { username: n } = await C(
    Yt(
      {
        [L.GITHUB]: "done-coding",
        [L.GITEE]: "justsosu"
      }[t]
    )
  );
  console.log("platform:", t), console.log("username:", n), await bo({
    platform: t,
    username: n,
    projectName: e
  });
}, jp = async (e) => {
  R.info(`版本: ${St.version}`);
  const { projectName: t, justCloneFromDoneCoding: n = !0 } = e;
  if (n) {
    R.info("仅仅(从done-coding系列项目列表中)克隆远程仓库"), await Pp(t);
    return;
  }
  const o = ((t ?? (await C(Ho)).projectName) || "").trim();
  if (!o)
    return R.error("项目名称不能为空"), process.exit(1);
  if (o.includes(" ") || o.includes("\\") || o.includes("/"))
    return R.error(`项目名称\`${o}\`不能包含空格或者\\或者/`), process.exit(1);
  const s = Bo(process.cwd(), o);
  if (nn(s)) {
    const { isRemove: m } = await C(Ko());
    if (m === !0)
      Pe(s, { recursive: !0, force: !0 });
    else
      return R.error(`项目${o}已存在`), process.exit(1);
  }
  const { template: i } = await C(await Go());
  let a = "", u = "";
  if (i === Gn) {
    const { customUrl: m } = await C(Wo);
    a = m;
  } else if (i === qn)
    a = await Mo();
  else {
    const m = (await Kn()).find(
      (h) => h.name === i
    );
    if (!m)
      return R.error(`模板${i}不存在`), process.exit(1);
    if (!m.url)
      return R.error(`模板${i}仓库地址不存在`), process.exit(1);
    a = m.url, u = m.branch;
  }
  const f = Hn(".git");
  R.stage("正在初始化项目，请稍等..."), Y(
    `git clone${u ? ` -b ${u}` : ""} ${a} ${o} --depth=1`,
    { stdio: "inherit" }
  );
  const c = Io, p = Do({
    rootDir: s,
    configPath: c
  });
  if (p && (await Lo({
    rootDir: s,
    configPath: c,
    extraEnvData: {
      $projectName: o
    }
  }), Pe(p, { force: !0 }), R.stage("模板项目配置注入成功, 模版项目配置文件已删除")), R.stage("项目初始化完成"), f) {
    const m = ye.resolve(s), h = ye.resolve(m, ".git");
    if (!nn(h))
      throw new Error("git目录不存在");
    Pe(h, { recursive: !0, force: !0 }), R.stage(
      `项目创建在父级git仓库${f}中，已删除${o}目录下的.git(${h})`
    );
  } else if ((await C(qo)).saveGitHistory)
    Y("git remote rename origin upstream && git fetch --unshallow", {
      cwd: s,
      stdio: "inherit"
    }), R.stage(
      "已经将origin重命名为upstream，后续可以与模板git仓库有完整的交互"
    ), R.success("已保存git历史记录");
  else {
    const h = ye.resolve(s, ".git");
    Pe(h, { recursive: !0, force: !0 }), Y("git init", {
      cwd: s,
      stdio: "inherit"
    });
  }
  const { gitCommitMessage: g } = await C(
    zo(o)
  );
  Y(`git add . && git commit -m '${g}'`, {
    cwd: s,
    stdio: "inherit"
  }), R.success(`项目${o}初始化完成`), R.info(`
使用步骤: 
  1. cd ${o}
  2. pnpm install
  3. pnpm run dev
  `);
}, {
  version: xp,
  description: Fp,
  cliConfig: { moduleName: Up }
} = St, Ro = {
  describe: Fp,
  version: xp,
  options: {
    justCloneFromDoneCoding: {
      alias: "c",
      type: "boolean",
      describe: "是否仅仅(从done-coding系列项目列表中)克隆远程仓库",
      default: !1
    }
  },
  positionals: {
    projectName: {
      describe: "项目名称",
      type: "string"
    }
  },
  handler: jp
}, Oo = (e = !1) => {
  const t = `${e ? `${Up} ` : ""}[projectName]`, n = `$0 ${t.trim()}`;
  return { command: t, usage: n };
}, Hp = async () => Uo({
  ...Ro,
  ...Oo()
}), Gp = () => kn({
  ...Ro,
  ...Oo(!0)
});
export {
  Gp as a,
  Hp as c,
  jp as h
};
