import type { CliHandlerArgv } from '@done-coding/cli-utils';
import { CommandModule } from 'yargs';

/** 作为子命令创建 */
export declare const crateAsSubcommand: () => CommandModule<{}, {}>;

export declare interface CreateConfigJson {
    templateList: CreateTemplateChoiceItem[];
}

/** 模版选项 */
export declare interface CreateTemplateChoiceItem {
    /** 模板名 */
    name: string;
    /** 仓库地址 */
    url?: string;
    /** 描述 */
    description?: string;
    /** 目标分支 */
    branch?: string;
    /** 应用实例 */
    instances?: string[];
}

export declare const handler: (argv: CliHandlerArgv<Options>) => Promise<undefined>;

export declare interface Options {
    /** 项目名称 */
    projectName?: string;
    /** 是否仅仅(从done-coding系列项目列表中)克隆远程仓库 */
    justCloneFromDoneCoding?: boolean;
}

export { }
